unit FrmDemo;

interface

uses
{$WARN UNIT_PLATFORM OFF}
  FileCtrl,
{$WARN UNIT_PLATFORM ON}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Dialogs, Forms, StdCtrls, ComCtrls, ExtCtrls,
  Spin, Buttons, TransLT.Obj, TransLT.API;

type
  TForm1 = class(TForm)
    ButtonSelectInputCooFile: TButton;
    ButtonSelectModelFile: TButton;
    ProgressBar1: TProgressBar;
    ButtonTransformFile: TButton;
    EditModelFileName: TEdit;
    LabelModelFileName: TLabel;
    EditGridsSearchPath: TEdit;
    LabelGridsSearchPath: TLabel;
    EditInputCooFileName: TEdit;
    CheckBoxUseReversedForFile: TCheckBox;
    ButtonSelectGridsPath: TButton;
    EditOutputCooFileName: TEdit;
    LabelInputCooFileName: TLabel;
    LabelOutputCooFileName: TLabel;
    MemoTest: TMemo;
    LabelMsgErrFile: TLabel;
    EditMsgErrFile: TEdit;
    ButtonSelectMsgErrFile: TButton;
    BevelTestForFile: TBevel;
    ButtonCheckIsCompatible: TButton;
    BevelTest1Pnt: TBevel;
    ButtonCheckIsReversible: TButton;
    ButtonModelHasCooOps: TButton;
    ButtonGetModelsCount: TButton;
    SpinEditModelIndex: TSpinEdit;
    LabelModelIndex: TLabel;
    BevelVert: TBevel;
    LabelTest1Pnt: TLabel;
    LabelTestForFile: TLabel;
    LabelIni_X_E_Phi: TLabel;
    EditIni_X_E_Phi: TEdit;
    LabelIni_Y_N_Lam: TLabel;
    EditIni_Y_N_Lam: TEdit;
    LabelIni_Z_H_h: TLabel;
    EditIni_Z_H_h: TEdit;
    ButtonShowDescription: TButton;
    BevelGenSettings: TBevel;
    LabelGenSettings: TLabel;
    LabelModelProp: TLabel;
    BevelModelProp: TBevel;
    LabelIniSysName: TLabel;
    LabelFin_X_E_Phi: TLabel;
    LabelFin_Y_N_Lam: TLabel;
    LabelFin_Z_H_h: TLabel;
    EditFin_X_E_Phi: TEdit;
    EditFin_Y_N_Lam: TEdit;
    EditFin_Z_H_h: TEdit;
    LabelFinSysName: TLabel;
    BitBtnTransfForward: TBitBtn;
    BitBtnTransfInverse: TBitBtn;
    ButtonIsCompatGE: TButton;
    LabelInputEntFileName: TLabel;
    Bevel1: TBevel;
    Label3: TLabel;
    ButtonSelectEntFile: TButton;
    ButtonCreateEntsTransAndDraw: TButton;
    EditInputEntFileName: TEdit;
    CheckBoxEntsUseReversed: TCheckBox;
    ButtonSaveEntFile: TButton;
    ButtonDrawInGE: TButton;
    BevelDefEnts: TBevel;
    LabelDefEnts: TLabel;
    LabelPnt1: TLabel;
    EditE1: TEdit;
    EditN1: TEdit;
    LabelPnt2: TLabel;
    EditE2: TEdit;
    EditN2: TEdit;
    LabelPnt3: TLabel;
    EditE3: TEdit;
    EditN3: TEdit;
    LabelPnt4: TLabel;
    EditE4: TEdit;
    EditN4: TEdit;
    LabelSysIniEnts: TLabel;
    EditEntsModelFileName: TEdit;
    LabelEntsModelFileName: TLabel;
    LabelPnt5: TLabel;
    EditE5: TEdit;
    EditN5: TEdit;
    LabelEntsGridsSearchPath: TLabel;
    EditEntsGridsSearchPath: TEdit;
    ButtonSelectEntsModelFile: TButton;
    ButtonSelectEntsGridsPath: TButton;
    LabelEntsModelIndex: TLabel;
    SpinEditEntsModelIndex: TSpinEdit;
    PanelEpoch: TPanel;
    LabelEpochT: TLabel;
    LabelEpochT0: TLabel;
    EditEpochT: TEdit;
    EditEpochT0: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButtonTransformFileClick(Sender: TObject);
    procedure ButtonSelectModelFileClick(Sender: TObject);
    procedure ButtonSelectInputCooFileClick(Sender: TObject);
    procedure ButtonSelectGridsPathClick(Sender: TObject);
    procedure ButtonSelectMsgErrFileClick(Sender: TObject);
    procedure ButtonCheckIsReversibleClick(Sender: TObject);
    procedure ButtonModelHasCooOpsClick(Sender: TObject);
    procedure ButtonCheckIsCompatibleClick(Sender: TObject);
    procedure ButtonGetModelsCountClick(Sender: TObject);
    procedure SpinEditModelIndexChange(Sender: TObject);
    procedure ButtonShowDescriptionClick(Sender: TObject);
    procedure BitBtnTransfForwardClick(Sender: TObject);
    procedure BitBtnTransfInverseClick(Sender: TObject);
    procedure EditModelFileNameExit(Sender: TObject);
    procedure ButtonIsCompatGEClick(Sender: TObject);
    procedure ButtonSelectEntFileClick(Sender: TObject);
    procedure ButtonSaveEntFileClick(Sender: TObject);
    procedure ButtonDrawInGEClick(Sender: TObject);
    procedure ButtonCreateEntsTransAndDrawClick(Sender: TObject);
    procedure ButtonSelectEntsGridsPathClick(Sender: TObject);
    procedure ButtonSelectEntsModelFileClick(Sender: TObject);
    procedure SpinEditEntsModelIndexChange(Sender: TObject);
  private
    {Private declarations}
    procedure TransformPoint(const ForwardDirection: boolean);
    procedure SetSelectedModel;
    procedure SetModelIndexValue(SpinEdit: TSpinEdit);
  public
    {Public declarations}
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  ProgressBar: TProgressBar = nil;

procedure MyProgressProc(const Procent: integer); stdcall;
begin
  if (ProgressBar <> nil) and (Procent >= 0) then
    ProgressBar.Position:= Procent;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
var
  ErrFile, ModelFile, GridPath, CooFile, GEdrawFile: string;
begin
  FormatSettings.DecimalSeparator := '.';
  FormatSettings.ThousandSeparator:= #0;

  Caption:= StringReplace(Caption, '...', ExtractFileName(TRLTDLLFILE), []);
{$IFDEF UNICODE}
  Caption:= Caption + ' (UNICODE)';
{$ELSE}
  Caption:= Caption + ' (ANSI)';
{$ENDIF}
  ProgressBar:= ProgressBar1;

  ErrFile:= ExpandFileName(EditMsgErrFile.Text);
  if FileExists(ErrFile) then
    begin
      SetErrMsgFile(ErrFile);
      EditMsgErrFile.Text:= GetErrMsgFile;
    end;

  ModelFile:= ExpandFileName(EditModelFileName.Text);
  if FileExists(ModelFile) then
    begin
      EditModelFileName.Text:= ModelFile;
    end;

  ModelFile:= ExpandFileName(EditEntsModelFileName.Text);
  if FileExists(ModelFile) then
    begin
      EditEntsModelFileName.Text:= ModelFile;
    end;

  GridPath:= ExpandFileName(EditGridsSearchPath.Text);
  if DirectoryExists(GridPath) then
    begin
      EditGridsSearchPath.Text:= GridPath;
    end;

  GridPath:= ExpandFileName(EditEntsGridsSearchPath.Text);
  if DirectoryExists(GridPath) then
    begin
      EditEntsGridsSearchPath.Text:= GridPath;
    end;

  CooFile:= ExpandFileName(EditInputCooFileName.Text);
  if FileExists(CooFile) then
    begin
      EditInputCooFileName.Text := CooFile;
      EditOutputCooFileName.Text:= ChangeFileExt(CooFile, '.csv');
    end;

  GEdrawFile:= ExpandFileName(EditInputEntFileName.Text);
  if FileExists(GEdrawFile) then
    begin
      EditInputEntFileName.Text:= GEdrawFile;
    end;

  SetSelectedModel;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //Delete temporary files used for drawing in Google Earth
  ClearTempFiles;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.SetModelIndexValue(SpinEdit: TSpinEdit);
begin
  if SpinEdit.Value > SpinEdit.MaxValue then
    SpinEdit.Value:= SpinEdit.MaxValue
  else if SpinEdit.Value < SpinEdit.MinValue then
    SpinEdit.Value:= SpinEdit.MinValue;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.SetSelectedModel;
var
  ModelDescription: TModelDescription;
begin
  if (EditModelFileName.Text <> '') and GetModelDescription(EditModelFileName.Text, SpinEditModelIndex.Value,
    ModelDescription) then
    begin
      with ModelDescription do
        begin
          ButtonTransformFile.Enabled       := True;
          CheckBoxUseReversedForFile.Enabled:= SupportReverseCalc;

          LabelEpochT0.Enabled:= IsUseTimeEpochT0;
          EditEpochT0.Enabled := IsUseTimeEpochT0;
          LabelEpochT.Enabled := IsUseTimeEpochT0 or IsTimeDependent;
          EditEpochT.Enabled  := IsUseTimeEpochT0 or IsTimeDependent;

          LabelIniSysName.Caption:= CooSysIniName;
          LabelFinSysName.Caption:= CooSysFinName;

          BitBtnTransfForward.Enabled:= True;
          BitBtnTransfInverse.Enabled:= SupportReverseCalc;

          case CooSysIniType of
            ctXYZ:
              begin
                LabelIni_X_E_Phi.Caption:= 'X =';
                LabelIni_Y_N_Lam.Caption:= 'Y =';
                LabelIni_Z_H_h.Caption  := 'Z =';

                LabelIni_Z_H_h.Enabled:= True;
                EditIni_Z_H_h.Enabled := True;
              end;
            ctGeo:
              begin
                LabelIni_X_E_Phi.Caption:= CH_PHI + ' =';
                LabelIni_Y_N_Lam.Caption:= CH_LAMBDA + ' =';
                LabelIni_Z_H_h.Caption  := 'h =';

                LabelIni_Z_H_h.Enabled:= (CooSysIniDim = cd3D);
                EditIni_Z_H_h.Enabled := (CooSysIniDim = cd3D);
              end;
            ctNEH:
              begin
                if AltNameAxisEini <> '' then
                  LabelIni_X_E_Phi.Caption:= 'E (' + AltNameAxisEini + ') ='
                else
                  LabelIni_X_E_Phi.Caption:= 'E =';

                if AltNameAxisNini <> '' then
                  LabelIni_Y_N_Lam.Caption:= 'N (' + AltNameAxisNini + ') ='
                else
                  LabelIni_Y_N_Lam.Caption:= 'N =';

                LabelIni_Z_H_h.Caption:= 'H =';

                LabelIni_Z_H_h.Enabled:= (CooSysIniDim = cd3D);
                EditIni_Z_H_h.Enabled := (CooSysIniDim = cd3D);
              end;
          end;

          case CooSysFinType of
            ctXYZ:
              begin
                LabelFin_X_E_Phi.Caption:= 'X =';
                LabelFin_Y_N_Lam.Caption:= 'Y =';
                LabelFin_Z_H_h.Caption  := 'Z =';

                LabelFin_Z_H_h.Enabled:= True;
                EditFin_Z_H_h.Enabled := True;
              end;
            ctGeo:
              begin
                LabelFin_X_E_Phi.Caption:= CH_PHI + ' =';
                LabelFin_Y_N_Lam.Caption:= CH_LAMBDA + ' =';
                LabelFin_Z_H_h.Caption  := 'h =';

                LabelFin_Z_H_h.Enabled:= (CooSysFinDim = cd3D);
                EditFin_Z_H_h.Enabled := (CooSysFinDim = cd3D);
              end;
            ctNEH:
              begin
                if AltNameAxisEfin <> '' then
                  LabelFin_X_E_Phi.Caption:= 'E (' + AltNameAxisEfin + ') ='
                else
                  LabelFin_X_E_Phi.Caption:= 'E =';

                if AltNameAxisNfin <> '' then
                  LabelFin_Y_N_Lam.Caption:= 'N (' + AltNameAxisNfin + ') ='
                else
                  LabelFin_Y_N_Lam.Caption:= 'N =';

                LabelFin_Z_H_h.Caption:= 'H =';

                LabelFin_Z_H_h.Enabled:= (CooSysFinDim = cd3D);
                EditFin_Z_H_h.Enabled := (CooSysFinDim = cd3D);
              end;
          end;
        end;
    end
  else
    begin
      ButtonTransformFile.Enabled       := False;
      CheckBoxUseReversedForFile.Enabled:= False;

      LabelIniSysName.Caption    := 'Initial coordinate system ...';
      LabelFinSysName.Caption    := 'Final coordinate system ...';
      BitBtnTransfForward.Enabled:= False;
      BitBtnTransfInverse.Enabled:= False;

      LabelIni_X_E_Phi.Caption:= 'X or E or ' + CH_PHI + ' =';
      LabelIni_Y_N_Lam.Caption:= 'Y or N or ' + CH_LAMBDA + ' =';
      LabelIni_Z_H_h.Caption  := 'Z or H or h =';

      LabelFin_X_E_Phi.Caption:= 'X or E or ' + CH_PHI + ' =';
      LabelFin_Y_N_Lam.Caption:= 'Y or N or ' + CH_LAMBDA + ' =';
      LabelFin_Z_H_h.Caption  := 'Z or H or h =';

      LabelIni_Z_H_h.Enabled:= True;
      EditIni_Z_H_h.Enabled := True;
      LabelFin_Z_H_h.Enabled:= True;
      EditFin_Z_H_h.Enabled := True;
    end;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.ButtonSelectMsgErrFileClick(Sender: TObject);
var
  FileName: string;
begin
  FileName:= EditMsgErrFile.Text;
  if PromptForFileName(FileName, 'File with error messages (*.err)|*.err', 'err', 'Select file with the error messages',
    ExtractFileDir(FileName), False) then
    begin
      EditMsgErrFile.Text:= FileName;
      SetErrMsgFile(FileName);
    end;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.ButtonSelectModelFileClick(Sender: TObject);
var
  ModelsCount: integer;
  FileName   : string;
begin
  FileName:= ExpandFileName(EditModelFileName.Text);
  if PromptForFileName(FileName, 'All known models files (*.mtr; *.mtrs; *.xml)|*.mtr;*.mtrs;*.xml', 'mtr',
    'Select file with the transformation model(s)', ExtractFileDir(FileName), False) then
    begin
      if GetModelFileIsCompatible(FileName) then
        begin
          EditModelFileName.Text:= FileName;

          ModelsCount:= GetCountModelsFromFile(FileName);
          if ModelsCount > 0 then
            SpinEditModelIndex.MaxValue:= ModelsCount
          else
            SpinEditModelIndex.MaxValue:= 1;

          SetModelIndexValue(SpinEditModelIndex);
        end
      else
        EditModelFileName.Text:= '';
    end;

  SetSelectedModel;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.EditModelFileNameExit(Sender: TObject);
begin
  SetSelectedModel;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.SpinEditModelIndexChange(Sender: TObject);
begin
  SetModelIndexValue(SpinEditModelIndex);
  SetSelectedModel;
end;

//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.ButtonCheckIsCompatibleClick(Sender: TObject);
var
  IsCompatible: boolean;
begin
  if EditModelFileName.Text <> '' then
    begin
      IsCompatible:= GetModelFileIsCompatible(EditModelFileName.Text);
      ShowMessage(BoolToStr(IsCompatible, True));
    end;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.ButtonGetModelsCountClick(Sender: TObject);
var
  ModelsCount: integer;
begin
  if EditModelFileName.Text <> '' then
    begin
      ModelsCount:= GetCountModelsFromFile(EditModelFileName.Text);
      ShowMessage(IntToStr(ModelsCount));
    end;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.ButtonModelHasCooOpsClick(Sender: TObject);
var
  HasSteps: boolean;
begin
  if EditModelFileName.Text <> '' then
    begin
      HasSteps:= GetModelHasCooOperations(EditModelFileName.Text, SpinEditModelIndex.Value);
      ShowMessage(BoolToStr(HasSteps, True));
    end;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.ButtonCheckIsReversibleClick(Sender: TObject);
var
  IsReversible: boolean;
begin
  if EditModelFileName.Text <> '' then
    begin
      IsReversible:= GetModelIsReversible(EditModelFileName.Text, SpinEditModelIndex.Value);
      ShowMessage(BoolToStr(IsReversible, True));
    end;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.ButtonIsCompatGEClick(Sender: TObject);
var
  IsCompatToDrawInGE: boolean;
begin
  if EditModelFileName.Text <> '' then
    begin
      IsCompatToDrawInGE:= GetModelIsCompatToDrawInGE(EditModelFileName.Text, SpinEditModelIndex.Value);
      ShowMessage(BoolToStr(IsCompatToDrawInGE, True));
    end;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.ButtonShowDescriptionClick(Sender: TObject);
var
  ModelDescription                            : TModelDescription;
  SysIniType, SysFinType, SysIniDim, SysFinDim: string;
begin
  if EditModelFileName.Text <> '' then
    if GetModelDescription(EditModelFileName.Text, SpinEditModelIndex.Value, ModelDescription) then
      with ModelDescription do
        begin
          case CooSysIniType of
            ctXYZ:
              SysIniType:= 'Geocentric cartesian (X,Y,Z)';
            ctGeo:
              if CooSysIniDim = cd2D then
                SysIniType:= 'Geographic (' + CH_PHI + ',' + CH_LAMBDA + ')'
              else
                SysIniType:= 'Geographic (' + CH_PHI + ',' + CH_LAMBDA + ',h)';
            ctNEH:
              if CooSysIniDim = cd2D then
                SysIniType:= 'Projected (N,E)'
              else
                SysIniType:= 'Projected (N,E,H)';
          end;

          case CooSysFinType of
            ctXYZ:
              SysFinType:= 'Geocentric cartesian (X,Y,Z)';
            ctGeo:
              if CooSysFinDim = cd2D then
                SysFinType:= 'Geographic (' + CH_PHI + ',' + CH_LAMBDA + ')'
              else
                SysFinType:= 'Geographic (' + CH_PHI + ',' + CH_LAMBDA + ',h)';
            ctNEH:
              if CooSysFinDim = cd2D then
                SysFinType:= 'Projected (N,E)'
              else
                SysFinType:= 'Projected (N,E,H)';
          end;

          case CooSysIniDim of
            cd2D:
              SysIniDim:= '2D';
            cd3D:
              SysIniDim:= '3D';
          end;

          case CooSysFinDim of
            cd2D:
              SysFinDim:= '2D';
            cd3D:
              SysFinDim:= '3D';
          end;

          ShowMessage(                                                //
            ' Model name: ' + ModelName + sLineBreak +               //
            ' Model description: ' + TransDescription + sLineBreak + //
            ' Initial Coordinate System Name: ' + CooSysIniName + sLineBreak + //
            ' Final Coordinate System Name: ' + CooSysFinName + sLineBreak + //
            ' Initial Coordinate System Type: ' + SysIniType + sLineBreak +  //
            ' Final Coordinate System Type: ' + SysFinType + sLineBreak +    //
            ' Initial Coordinate System Dimension: ' + SysIniDim + sLineBreak + //
            ' Final Coordinate System Dimension: ' + SysFinDim + sLineBreak + //
            ' CRS code for initial system from EPSG database: ' + IntToStr(CodeCRSini) + sLineBreak + //
            ' CRS code for final system from EPSG database: ' + IntToStr(CodeCRSfin) + sLineBreak + //
            ' Alternative name for the North axis, the initial system: ' + AltNameAxisNini + sLineBreak + //
            ' Alternative name for the East axis, the initial system: ' + AltNameAxisEini + sLineBreak + //
            ' Alternative name for the North axis, the final system: ' + AltNameAxisNfin + sLineBreak + //
            ' Alternative name for the East axis, the final system: ' + AltNameAxisEfin + sLineBreak + //
            ' Total accuracy of the transformation: ' + FloatToStr(TotalAcurracy) + sLineBreak + //
            ' Model supports the reverse transformation: ' + BoolToStr(SupportReverseCalc, True) + sLineBreak + //
            ' Model is time-dependent: ' + BoolToStr(IsTimeDependent, True));
        end;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.ButtonSelectGridsPathClick(Sender: TObject);
var
  Directory: string;
begin
  Directory:= EditGridsSearchPath.Text;
  if not SysUtils.DirectoryExists(Directory) then
    Directory:= GetCurrentDir;

  if SelectDirectory(Directory, [], 0) then
    begin
      EditGridsSearchPath.Text:= Directory;
    end;
end;

//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.ButtonSelectInputCooFileClick(Sender: TObject);
var
  FileName: string;
begin
  FileName:= EditInputCooFileName.Text;
  if PromptForFileName(FileName, 'All files (*.*)|*.*', '', 'Select coordinates file', ExtractFileDir(FileName), False)
  then
    begin
      EditInputCooFileName.Text := FileName;
      EditOutputCooFileName.Text:= ChangeFileExt(FileName, '.csv');
    end;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.ButtonTransformFileClick(Sender: TObject);
var
  TransformPoints: TTransformPoints;
begin
  if EditOutputCooFileName.Text = '' then
    Exit;

  TransformPoints:= TTransformPoints.Create(EditModelFileName.Text, SpinEditModelIndex.Value, puMeter,
    CheckBoxUseReversedForFile.Checked and CheckBoxUseReversedForFile.Enabled, EditGridsSearchPath.Text);
  Try
    TransformPoints.DecNoNEH  := 8;
    TransformPoints.DecNoSec  := 8;
    TransformPoints.DecNoGeoHe:= 8;

    if TransformPoints.ModelIsLoaded and TransformPoints.LoadCooPointsFromFile(EditInputCooFileName.Text) and
      (TransformPoints.CountCooPoints > 0) then
      begin
        if TransformPoints.IsUseTimeEpochT0 then
          begin
            TransformPoints.EpochT0:= StrToFloat(EditEpochT0.Text);
            TransformPoints.EpochT := StrToFloat(EditEpochT.Text);
          end
        else if TransformPoints.IsTimeDependent then
          begin
            TransformPoints.EpochT:= StrToFloat(EditEpochT.Text);
          end;

        if TransformPoints.ApplyTransformation(MyProgressProc) then
          begin
            if TransformPoints.SaveCooPointsToFile(EditOutputCooFileName.Text, False, etUnicode) then
              ShowMessage('Test completed successfully ...' + #13 +
                'The calculated coordinates have been saved in file ...');
          end;
      end;
  Finally
    TransformPoints.Free;
  End;

  ProgressBar1.Position:= 0;
end;

//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.TransformPoint(const ForwardDirection: boolean);
var
  TransformPoints                                          : TTransformPoints;
  XorEorPhi, YorNorLam, ZorHorHe                           : extended;
  PntName, PntCode, StrXorEorPhi, StrYorNorLam, StrZorHorHe: string;
const
  MAX_DIGITS = SizeOf(extended) + SizeOf(double);
begin
  MemoTest.Lines.Clear;

  Try
    PntName:= 'Pnt1';
    if ForwardDirection then
      begin
        XorEorPhi:= StrToFloat(EditIni_X_E_Phi.Text);
        YorNorLam:= StrToFloat(EditIni_Y_N_Lam.Text);
        ZorHorHe := StrToFloat(EditIni_Z_H_h.Text);
      end
    else
      begin
        XorEorPhi:= StrToFloat(EditFin_X_E_Phi.Text);
        YorNorLam:= StrToFloat(EditFin_Y_N_Lam.Text);
        ZorHorHe := StrToFloat(EditFin_Z_H_h.Text);
      end;
    PntCode:= 'Code1';

    TransformPoints:= TTransformPoints.Create(EditModelFileName.Text, SpinEditModelIndex.Value, puMeter,
      not ForwardDirection, EditGridsSearchPath.Text);
    Try
      TransformPoints.DecNoNEH  := 8;
      TransformPoints.DecNoSec  := 8;
      TransformPoints.DecNoGeoHe:= 8;

      if TransformPoints.ModelIsLoaded then
        begin
          TransformPoints.AddCooPoint(PntName, XorEorPhi, YorNorLam, ZorHorHe, PntCode);

          MemoTest.Lines.Add('Initial coordinates system: ' + TransformPoints.ModelDescription.CooSysIniName);
          MemoTest.Lines.Add('Point:');
          TransformPoints.GetCooPointFormated(0, PntName, StrXorEorPhi, StrYorNorLam, StrZorHorHe, PntCode);

          MemoTest.Lines.Add(PntName + ' ' + StrXorEorPhi + ' ' + StrYorNorLam + ' ' + StrZorHorHe + ' ' + PntCode);

          if TransformPoints.IsUseTimeEpochT0 then
            begin
              TransformPoints.EpochT0:= StrToFloat(EditEpochT0.Text);
              TransformPoints.EpochT := StrToFloat(EditEpochT.Text);
            end
          else if TransformPoints.IsTimeDependent then
            begin
              TransformPoints.EpochT:= StrToFloat(EditEpochT.Text);
            end;

          if TransformPoints.ApplyTransformation(nil) then
            begin
              TransformPoints.GetCooPoint(0, PntName, XorEorPhi, YorNorLam, ZorHorHe, PntCode);
              if ForwardDirection then
                begin
                  EditFin_X_E_Phi.Text:= FloatToStrF(XorEorPhi, ffGeneral, MAX_DIGITS, 0);
                  EditFin_Y_N_Lam.Text:= FloatToStrF(YorNorLam, ffGeneral, MAX_DIGITS, 0);
                  EditFin_Z_H_h.Text  := FloatToStrF(ZorHorHe, ffGeneral, MAX_DIGITS, 0);
                end
              else
                begin
                  EditIni_X_E_Phi.Text:= FloatToStrF(XorEorPhi, ffGeneral, MAX_DIGITS, 0);
                  EditIni_Y_N_Lam.Text:= FloatToStrF(YorNorLam, ffGeneral, MAX_DIGITS, 0);
                  EditIni_Z_H_h.Text  := FloatToStrF(ZorHorHe, ffGeneral, MAX_DIGITS, 0);
                end;

              MemoTest.Lines.Add('');
              MemoTest.Lines.Add('Final coordinates system: ' + TransformPoints.ModelDescription.CooSysFinName);
              MemoTest.Lines.Add('Calculated point:');
              TransformPoints.GetCooPointFormated(0, PntName, StrXorEorPhi, StrYorNorLam, StrZorHorHe, PntCode);
              MemoTest.Lines.Add(PntName + ' ' + StrXorEorPhi + ' ' + StrYorNorLam + ' ' + StrZorHorHe + ' ' + PntCode);
            end;

          MemoTest.SelStart := 0;
          MemoTest.SelLength:= 0;
        end;
    Finally
      TransformPoints.Free;
    End;
  Except
    on E: Exception do
      begin
        ShowMessage(E.Message);
      end;
  End;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.BitBtnTransfForwardClick(Sender: TObject);
begin
  TransformPoint(True);
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.BitBtnTransfInverseClick(Sender: TObject);
begin
  TransformPoint(False);
end;

//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.ButtonSelectEntFileClick(Sender: TObject);
var
  FileName: string;
begin
  FileName:= EditInputEntFileName.Text;
  if PromptForFileName(FileName, 'TransLT entities file (*.csv)|*.csv|' +
    'Extensible Markup Language file (*.xml)|*.xml', 'csv', 'Select file with entities', ExtractFileDir(FileName), False)
  then
    begin
      EditInputEntFileName.Text:= FileName;
    end;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.ButtonSaveEntFileClick(Sender: TObject);
var
  FileName           : string;
  TransformEntitiesGE: TTransformEntitiesGE;
begin
  //Used only to load from file and save to another file, input file is in
  //(phi, lambda)
  TransformEntitiesGE:= TTransformEntitiesGE.Create(EditModelFileName.Text, SpinEditModelIndex.Value, puMeter,
    False, '');
  Try
    if TransformEntitiesGE.ModelIsLoaded then
      begin
        TransformEntitiesGE.ChCsv:= ';';

        if TransformEntitiesGE.LoadEntitiesFromFile(EditInputEntFileName.Text) then
          begin
            FileName:= EditInputEntFileName.Text;
            if PromptForFileName(FileName,
              'All known entities files (*.csv; *.xml; *.kml; *.kmz)|*.csv;*.xml;*.kml;*.kmz|' +
              'TransLT entities file (*.csv)|*.csv|' + 'Extensible Markup Language file (*.xml)|*.xml|' +
              'Google Earth (*.kml)|*.kml|' + 'Google Earth compressed (*.kmz)|*.kmz', 'csv', 'Save entities to file',
              ExtractFileDir(FileName), True) then
              begin
                TransformEntitiesGE.SaveEntitiesToFile(FileName, etUnicode);
              end;
          end;
      end;
  Finally
    TransformEntitiesGE.Free;
  End;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.ButtonDrawInGEClick(Sender: TObject);
var
  TransformEntitiesGE: TTransformEntitiesGE;
begin
  //Used only to load and next to draw in Google Earth, input file is in
  //(phi, lambda) and in this case the transformation is not necessary.
  TransformEntitiesGE:= TTransformEntitiesGE.Create(EditModelFileName.Text, SpinEditModelIndex.Value, puMeter,
    False, '');
  Try
    if TransformEntitiesGE.ModelIsLoaded then
      begin
        TransformEntitiesGE.ChCsv:= ';';

        if TransformEntitiesGE.LoadEntitiesFromFile(EditInputEntFileName.Text) then
          begin
            TransformEntitiesGE.DrawEntitiesToGoogleEarth;
          end;
      end;
  Finally
    TransformEntitiesGE.Free;
  End;
end;

//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.ButtonSelectEntsModelFileClick(Sender: TObject);
var
  ModelsCount: integer;
  FileName   : string;
begin
  FileName:= ExpandFileName(EditEntsModelFileName.Text);
  if PromptForFileName(FileName, 'All known models files (*.mtr; *.mtrs; *.xml)|*.mtr;*.mtrs;*.xml', 'mtr',
    'Select file with the transformation model(s)', ExtractFileDir(FileName), False) then
    begin
      if GetModelFileIsCompatible(FileName) then
        begin
          EditEntsModelFileName.Text:= FileName;

          ModelsCount:= GetCountModelsFromFile(FileName);
          if ModelsCount > 0 then
            SpinEditEntsModelIndex.MaxValue:= ModelsCount
          else
            SpinEditEntsModelIndex.MaxValue:= 1;

          SetModelIndexValue(SpinEditEntsModelIndex);
        end
      else
        EditEntsModelFileName.Text:= '';
    end;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.ButtonSelectEntsGridsPathClick(Sender: TObject);
var
  Directory: string;
begin
  Directory:= EditEntsGridsSearchPath.Text;
  if not SysUtils.DirectoryExists(Directory) then
    Directory:= GetCurrentDir;

  if SelectDirectory(Directory, [], 0) then
    begin
      EditEntsGridsSearchPath.Text:= Directory;
    end;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.SpinEditEntsModelIndexChange(Sender: TObject);
begin
  SetModelIndexValue(SpinEditEntsModelIndex);
end;

//----------------------------------------------------------------------------------------------------------------------
procedure TForm1.ButtonCreateEntsTransAndDrawClick(Sender: TObject);
var
  TransformEntitiesGE: TTransformEntitiesGE;
  GEEntityProperties : TGEEntityProperties;
begin
  TransformEntitiesGE:= TTransformEntitiesGE.Create(EditEntsModelFileName.Text, SpinEditEntsModelIndex.Value, puMeter,
    CheckBoxEntsUseReversed.Checked, EditEntsGridsSearchPath.Text);
  Try
    if TransformEntitiesGE.ModelIsLoaded then
      begin
        //Add entity polygon
        with GEEntityProperties do
          begin
            FillChar(GEEntityProperties, SizeOf(TGEEntityProperties), 0);
            EntityType:= etPolygon;
            Info1     := '100/1';
            Info2     := 'Vodafone property';
            InfoA     := ''; //Values will be calculated
            InfoL     := ''; //after adding points.
            AddAtoName:= True;
            AddLtoName:= True;
            InfoAd1   := 'Other info 1';
            InfoAd2   := 'Other info 2';
            InfoAd3   := 'Other info 3';
            InfoAd4   := 'Other info 4';
            InfoAd5   := 'Other info 5';
            InfoAd6   := 'Other info 6';
            IdxImgSymb:= 0;
            StrLCopy(HtmlColor, PWideChar(ColorToStringHtml(50, 0, 170, 255)), MAX_LEN_HTML_COLOR);
            LinesWidth := 2.0; //pixels
            UseAddBox  := True;
            UseAddInfo1:= True;
            UseAddInfo2:= True;
            UseAddInfoA:= True;
            UseAddInfoL:= True;
            UseAddAdr  := True;
            AddAdr     := 'Sos. Bucuresti Nord';
            UseAddDest := False;
            AddDest    := '';
            UseAddUsage:= False;
            AddUsage   := '';
            UseAddLnk  := True;
            AddLinkName:= 'My home page';
            AddLinkURL := 'http://www.topolt.com/';
            SubFolder  := '';

            //Draw the polygon with properties from the TGEDrawOptions
            HtmlLineColor := '';
            HtmlLabelColor:= '';
            DrawLabel     := dltDefault;
            LabelScale    := 1.0;
            SymbolScale   := 1.0;
            //If you want to draw the polygon with properties different from the TGEDrawOptions
            //StrLCopy(HtmlLineColor, PWideChar(ColorToStringHtml(100, 255, 0, 0)), MAX_LEN_HTML_COLOR);
            //StrLCopy(HtmlLabelColor, PWideChar(ColorToStringHtml(100, 255, 0, 0)), MAX_LEN_HTML_COLOR);
            //DrawLabel:= dltNotDraw;
          end;
        TransformEntitiesGE.AddEntity(GEEntityProperties);

        TransformEntitiesGE.AddPointToEntity(0, 'Pnt1', StrToFloat(EditE1.Text), StrToFloat(EditN1.Text));
        TransformEntitiesGE.AddPointToEntity(0, 'Pnt2', StrToFloat(EditE2.Text), StrToFloat(EditN2.Text));
        TransformEntitiesGE.AddPointToEntity(0, 'Pnt3', StrToFloat(EditE3.Text), StrToFloat(EditN3.Text));
        TransformEntitiesGE.AddPointToEntity(0, 'Pnt4', StrToFloat(EditE4.Text), StrToFloat(EditN4.Text));
        TransformEntitiesGE.AddPointToEntity(0, 'Pnt5', StrToFloat(EditE5.Text), StrToFloat(EditN5.Text));

        TransformEntitiesGE.CalculateAreaAndLengthToEntity(0);

        //Add entity points group
        with GEEntityProperties do
          begin
            FillChar(GEEntityProperties, SizeOf(TGEEntityProperties), 0);
            EntityType:= etGrpPts;
            Info1     := 'Points';
            Info2     := '';
            InfoA     := '';
            InfoL     := '';
            AddAtoName:= False;
            AddLtoName:= False;
            InfoAd1   := 'Measured points';
            InfoAd2   := '';
            InfoAd3   := '';
            InfoAd4   := '';
            InfoAd5   := '';
            InfoAd6   := '';
            IdxImgSymb:= 0;
            StrLCopy(HtmlColor, PWideChar(ColorToStringHtml(100, 255, 255, 255)), MAX_LEN_HTML_COLOR);
            LinesWidth := 0.0;
            UseAddBox  := True;
            UseAddInfo1:= True;
            UseAddInfo2:= True;
            UseAddInfoA:= False;
            UseAddInfoL:= False;
            UseAddAdr  := False;
            AddAdr     := '';
            UseAddDest := False;
            AddDest    := '';
            UseAddUsage:= False;
            AddUsage   := '';
            UseAddLnk  := True;
            AddLinkName:= 'My home page';
            AddLinkURL := 'http://www.topolt.com/';
            SubFolder  := '';

            //Draw the points with label color from the TGEDrawOptions
            DrawLabel     := dltDefault;
            HtmlLabelColor:= '';
            LabelScale    := 0.7;
            SymbolScale   := 0.7;
            //If you want to draw the points with properties different from the TGEDrawOptions
            //StrLCopy(HtmlLabelColor, PWideChar(ColorToStringHtml(100, 255, 0, 0)), MAX_LEN_HTML_COLOR);
            //DrawLabel:= dltDraw;
          end;
        TransformEntitiesGE.AddEntity(GEEntityProperties);

        TransformEntitiesGE.AddPointToEntity(1, 'Pnt1', StrToFloat(EditE1.Text), StrToFloat(EditN1.Text));
        TransformEntitiesGE.AddPointToEntity(1, 'Pnt2', StrToFloat(EditE2.Text), StrToFloat(EditN2.Text));
        TransformEntitiesGE.AddPointToEntity(1, 'Pnt3', StrToFloat(EditE3.Text), StrToFloat(EditN3.Text));
        TransformEntitiesGE.AddPointToEntity(1, 'Pnt4', StrToFloat(EditE4.Text), StrToFloat(EditN4.Text));
        TransformEntitiesGE.AddPointToEntity(1, 'Pnt5', StrToFloat(EditE5.Text), StrToFloat(EditN5.Text));

        if TransformEntitiesGE.IsTimeDependent then
          begin
            ShowMessage('Warning: You must enter the value of the time t' + #13 +
              'because the model is time-dependent.');
          end
        else if TransformEntitiesGE.TransformPointsOfAllEntities(MyProgressProc) then
          begin
            TransformEntitiesGE.DrawEntitiesToGoogleEarth;
          end;
      end;
  Finally
    TransformEntitiesGE.Free;
  End;

  ProgressBar1.Position:= 0;
end;

//----------------------------------------------------------------------------------------------------------------------

end.
