#ifndef INCLUDED_TRANSLT_OBJ_H
#define INCLUDED_TRANSLT_OBJ_H
 
#include <stdio.h>
#include "TransLT_API.h"

#pragma comment (lib, "user32.lib")

#ifdef UNICODE
  #if (_MSC_VER >= 1300)
    //MSVC++ 7.0, ...
    #define TLstrlen wcslen
    #define TLstrcpy wcsncpy_s
    #define TLstrdup _wcsdup
    #define TLstrtol wcstol
    #define TLwcsncpy wcsncpy_s
    #define STRCAT(str1, len, str2) wcscat_s(str1, len, str2)
    #define WCSCAT(str1, len, str2) wcscat_s(str1, len, str2)
    #define MEMCPY(dest, nelem, sources, count) memcpy_s(dest, nelem, sources, count)
    #define SPRINTF(buf, frm, arg1, arg2) swprintf_s(buf, frm, arg1, arg2);
    #define SPRINTF_S(buf, szbuf, frm, arg1, arg2) swprintf_s(buf, szbuf, frm, arg1, arg2);
  #else
    //MSVC++ 6.0
    #define TLstrlen wcslen
    #define TLstrcpy wcsncpy
    #define TLstrdup _wcsdup
    #define TLstrtol wcstol
    #define TLwcsncpy wcsncpy
    #define STRCAT(str1, len, str2) wcsncat(str1, str2, len)
    #define WCSCAT(str1, len, str2) wcsncat(str1, str2, len)
    #define MEMCPY(dest, nelem, sources, count) memcpy(dest, sources, nelem)
    #define SPRINTF(buf, frm, arg1, arg2) wprintf(buf, frm, arg1, arg2);
    #define SPRINTF_S(buf, szbuf, frm, arg1, arg2) wprintf(buf, frm, arg1, arg2);
  #endif
#else
  #if (_MSC_VER >= 1300)
    //MSVC++ 7.0, ...
    #define TLstrlen strlen
    #define TLstrcpy strncpy_s
    #define TLstrdup _strdup
    #define TLstrtol strtol
    #define TLwcsncpy wcsncpy_s
    #define STRCAT(str1, len, str2) strcat_s(str1, len, str2)
    #define WCSCAT(str1, len, str2) wcscat_s(str1, len, str2)
    #define MEMCPY(dest, nelem, sources, count) memcpy_s(dest, nelem, sources, count)
    #define SPRINTF(buf, frm, arg1, arg2) sprintf_s(buf, frm, arg1, arg2);
    #define SPRINTF_S(buf, szbuf, frm, arg1, arg2) sprintf_s(buf, szbuf, frm, arg1, arg2);
  #else
    //MSVC++ 6.0
    #define TLstrlen strlen
    #define TLstrcpy strncpy
    #define TLstrdup _strdup
    #define TLstrtol strtol
    #define TLwcsncpy wcsncpy
    #define STRCAT(str1, len, str2) strncat(str1, str2, len)
    #define WCSCAT(str1, len, str2) wcsncat(str1, str2, len)
    #define MEMCPY(dest, nelem, sources, count) memcpy(dest, sources, nelem)
    #define SPRINTF(buf, frm, arg1, arg2) sprintf(buf, frm, arg1, arg2);
    #define SPRINTF_S(buf, szbuf, frm, arg1, arg2) sprintf(buf, frm, arg1, arg2);
  #endif
#endif

void StrWCopy(LPWSTR Dest, const LPCTSTR Source, int MaxLen);
#ifndef UNICODE
  void StrWCopy(LPSTR Dest, const LPCTSTR Source, int MaxLen);
#endif

TGEEntLangWords GEEntLangWords;
TGEKmlLangWords GEKmlLangWords;
TCHAR strFoldPolygons [MAX_LEN_FOLDER_NAME] = _T("");
TCHAR strFoldPaths    [MAX_LEN_FOLDER_NAME] = _T("");
TCHAR strFoldGroupPts [MAX_LEN_FOLDER_NAME] = _T("");
wchar_t strCooOpForErr[MAX_LEN_FOLDER_NAME] = L"";
BOOL TempFilesIsUsed = FALSE;

BOOL LibBoolToBool(const BOOL b);

#ifdef UNICODE
  TCHAR CH_PHI[7]    = L"\x03C6"; //Latitude  (Greek Small Letter Phi)
  TCHAR CH_LAMBDA[7] = L"\x03BB"; //Longitude (Greek Small Letter Lambda)
#else
  TCHAR CH_PHI[7]    = "phi";     //Latitude
  TCHAR CH_LAMBDA[7] = "lambda";  //Longitude
#endif

SETERRMSGFILENAME SetErrMsgFileName;
GETERRMSGFILENAME GetErrMsgFileName;

MODELFILEISCOMPATIBLE ModelFileIsCompatible;
MODELHASCOOOPERATIONS ModelHasCooOperations;
MODELISREVERSIBLE ModelIsReversible;
MODELISCOMPATIBLETODRAWINGOOGLEEARTH ModelIsCompatibleToDrawInGoogleEarth;
GETMODELDESCRIPTIONFROMFILE GetModelDescriptionFromFile;
GETCOUNTMODELS GetCountModels;

INITTRPNTMODEL InitTrPntModel;
DONETRPNTMODEL DoneTrPntModel;
GETTRPNTMODELDESCRIPTION GetTrPntModelDescription;
SETTRPNTEPOCHT0 SetTrPntEpochT0;
GETTRPNTEPOCHT0 GetTrPntEpochT0;
SETTRPNTEPOCHT SetTrPntEpochT;
GETTRPNTEPOCHT GetTrPntEpochT;
ADDPOINT AddPoint;
SETPOINT SetPoint;
DELETEPOINT DeletePoint;
DELETEALLPOINTS DeleteAllPoints;
GETPOINT GetPoint;
GETPOINTFORMATED GetPointFormated;
GETCOUNTPOINTS GetCountPoints;
LOADPOINTSFROMFILE LoadPointsFromFile;
SAVEPOINTSTOFILE SavePointsToFile;
TRANSFORMPOINTS TransformPoints;

INITTRGEMODEL InitTrGEModel;
DONETRGEMODEL DoneTrGEModel;
GETTRGEMODELDESCRIPTION GetTrGEModelDescription;
SETTRGEEPOCHT0 SetTrGEEpochT0;
GETTRGEEPOCHT0 GetTrGEEpochT0;
SETTRGEEPOCHT SetTrGEEpochT;
GETTRGEEPOCHT GetTrGEEpochT;
ADDGEENTITY AddGEEntity;
SETGEENTITY SetGEEntity;
DELETEGEENTITY DeleteGEEntity;
GETGEENTITY GetGEEntity;
CLEARGEENTITIES ClearGEEntities;
GETCOUNTGEENTITES GetCountGEEntites;
ADDPOINTTOGEENTITY AddPointToGEEntity;
SETPOINTTOGEENTITY SetPointToGEEntity;
GETPOINTFROMGEENTITY GetPointFromGEEntity;
GETPOINTFROMGEENTITYFORMATED GetPointFromGEEntityFormated;
GETCOUNTPOINTSOFGEENTITY GetCountPointsOfGEEntity;
DELETEALLPOINTSOFGEENTITY DeleteAllPointsOfGEEntity;
CALCULATEAREAANDLENGTHTOGEENTITY CalculateAreaAndLengthToGEEntity;
LOADGEENTITIESFROMFILE LoadGEEntitiesFromFile;
SAVEGEENTITIESTOFILE SaveGEEntitiesToFile;
DRAWGEENTITIESTOGOOGLEEARTH DrawGEEntitiesToGoogleEarth;
SAVEGEZOOMTOFILE SaveGEZoomToFile;
DRAWGEZOOMTOGOOGLEEARTH DrawGEZoomToGoogleEarth;
CLEARTEMPFILESGE ClearTempFilesGE;
TRANSFORMPOINTSOFALLGEENTITIES TransformPointsOfAllGEEntities;

//-------------------------------------------------------------------------------------------------------------
//---------------------------- Dll Library Initialization and Finalization ------------------------------------
//-------------------------------------------------------------------------------------------------------------
void DllInitialization(void)
{
  hDllImporter = LoadLibrary(TRLTDLLFILE);
  if (hDllImporter) {
    SetErrMsgFileName = (SETERRMSGFILENAME) GetProcAddress(hDllImporter, "SetErrMsgFileName");
    GetErrMsgFileName = (GETERRMSGFILENAME) GetProcAddress(hDllImporter, "GetErrMsgFileName");

    ModelFileIsCompatible = (MODELFILEISCOMPATIBLE) GetProcAddress(hDllImporter, "ModelFileIsCompatible");
    ModelHasCooOperations = (MODELHASCOOOPERATIONS) GetProcAddress(hDllImporter, "ModelHasCooOperations");
    ModelIsReversible = (MODELISREVERSIBLE) GetProcAddress(hDllImporter, "ModelIsReversible");
    ModelIsCompatibleToDrawInGoogleEarth = (MODELISCOMPATIBLETODRAWINGOOGLEEARTH) GetProcAddress(hDllImporter, 
                                           "ModelIsCompatibleToDrawInGoogleEarth");
    GetModelDescriptionFromFile = (GETMODELDESCRIPTIONFROMFILE) GetProcAddress(hDllImporter, 
                                  "GetModelDescriptionFromFile");
    GetCountModels = (GETCOUNTMODELS) GetProcAddress(hDllImporter, "GetCountModels");

    InitTrPntModel = (INITTRPNTMODEL) GetProcAddress(hDllImporter, "InitTrPntModel");
    DoneTrPntModel = (DONETRPNTMODEL) GetProcAddress(hDllImporter, "DoneTrPntModel");
    GetTrPntModelDescription = (GETTRPNTMODELDESCRIPTION) GetProcAddress(hDllImporter, "GetTrPntModelDescription");
    SetTrPntEpochT0 = (SETTRPNTEPOCHT0)GetProcAddress(hDllImporter, "SetTrPntEpochT0_64bit");
    GetTrPntEpochT0 = (GETTRPNTEPOCHT0)GetProcAddress(hDllImporter, "GetTrPntEpochT0_64bit");
    SetTrPntEpochT = (SETTRPNTEPOCHT)GetProcAddress(hDllImporter, "SetTrPntEpochT_64bit");
    GetTrPntEpochT = (GETTRPNTEPOCHT) GetProcAddress(hDllImporter, "GetTrPntEpochT_64bit");
    AddPoint = (ADDPOINT) GetProcAddress(hDllImporter, "AddPoint64bit");
    SetPoint = (SETPOINT) GetProcAddress(hDllImporter, "SetPoint64bit");
    GetPoint = (GETPOINT) GetProcAddress(hDllImporter, "GetPoint64bit");
    GetPointFormated = (GETPOINTFORMATED) GetProcAddress(hDllImporter, "GetPointFormated");
    DeletePoint = (DELETEPOINT) GetProcAddress(hDllImporter, "DeletePoint");
    DeleteAllPoints = (DELETEALLPOINTS)GetProcAddress(hDllImporter, "DeleteAllPoints");
    GetCountPoints = (GETCOUNTPOINTS)GetProcAddress(hDllImporter, "GetCountPoints");
    LoadPointsFromFile = (LOADPOINTSFROMFILE) GetProcAddress(hDllImporter, "LoadPointsFromFile");
    SavePointsToFile = (SAVEPOINTSTOFILE) GetProcAddress(hDllImporter, "SavePointsToFile");
    TransformPoints = (TRANSFORMPOINTS) GetProcAddress(hDllImporter, "TransformPoints");
    
    InitTrGEModel = (INITTRGEMODEL) GetProcAddress(hDllImporter, "InitTrGEModel");
    DoneTrGEModel = (DONETRGEMODEL) GetProcAddress(hDllImporter, "DoneTrGEModel");
    GetTrGEModelDescription = (GETTRGEMODELDESCRIPTION) GetProcAddress(hDllImporter, "GetTrGEModelDescription");
    SetTrGEEpochT0 = (SETTRGEEPOCHT0)GetProcAddress(hDllImporter, "SetTrGEEpochT0_64bit");
    GetTrGEEpochT0 = (GETTRGEEPOCHT0)GetProcAddress(hDllImporter, "GetTrGEEpochT0_64bit");
    SetTrGEEpochT = (SETTRGEEPOCHT)GetProcAddress(hDllImporter, "SetTrGEEpochT_64bit");
    GetTrGEEpochT = (GETTRGEEPOCHT) GetProcAddress(hDllImporter, "GetTrGEEpochT_64bit");
    AddGEEntity = (ADDGEENTITY) GetProcAddress(hDllImporter, "AddGEEntity");
    SetGEEntity = (SETGEENTITY) GetProcAddress(hDllImporter, "SetGEEntity");
    DeleteGEEntity = (DELETEGEENTITY) GetProcAddress(hDllImporter, "DeleteGEEntity");
    GetGEEntity = (GETGEENTITY) GetProcAddress(hDllImporter, "GetGEEntity");
    ClearGEEntities = (CLEARGEENTITIES) GetProcAddress(hDllImporter, "ClearGEEntities");
    GetCountGEEntites = (GETCOUNTGEENTITES) GetProcAddress(hDllImporter, "GetCountGEEntites");
    AddPointToGEEntity = (ADDPOINTTOGEENTITY) GetProcAddress(hDllImporter, "AddPointToGEEntity64bit");
    SetPointToGEEntity = (SETPOINTTOGEENTITY) GetProcAddress(hDllImporter, "SetPointToGEEntity64bit");
    GetPointFromGEEntity = (GETPOINTFROMGEENTITY) GetProcAddress(hDllImporter, "GetPointFromGEEntity64bit");
    GetPointFromGEEntityFormated = (GETPOINTFROMGEENTITYFORMATED) GetProcAddress(hDllImporter, 
                                   "GetPointFromGEEntityFormated");
    GetCountPointsOfGEEntity = (GETCOUNTPOINTSOFGEENTITY) GetProcAddress(hDllImporter, 
                               "GetCountPointsOfGEEntity");
    DeleteAllPointsOfGEEntity = (DELETEALLPOINTSOFGEENTITY) GetProcAddress(hDllImporter, 
                                "DeleteAllPointsOfGEEntity");
    CalculateAreaAndLengthToGEEntity = (CALCULATEAREAANDLENGTHTOGEENTITY) GetProcAddress(hDllImporter, 
                                       "CalculateAreaAndLengthToGEEntity");
    LoadGEEntitiesFromFile = (LOADGEENTITIESFROMFILE) GetProcAddress(hDllImporter, 
                                "LoadGEEntitiesFromFile");
    SaveGEEntitiesToFile = (SAVEGEENTITIESTOFILE)GetProcAddress(hDllImporter, "SaveGEEntitiesToFile");
    DrawGEEntitiesToGoogleEarth = (DRAWGEENTITIESTOGOOGLEEARTH) GetProcAddress(hDllImporter, 
                                  "DrawGEEntitiesToGoogleEarth");
    SaveGEZoomToFile = (SAVEGEZOOMTOFILE)GetProcAddress(hDllImporter, "SaveGEZoomToFile");
    DrawGEZoomToGoogleEarth = (DRAWGEZOOMTOGOOGLEEARTH)GetProcAddress(hDllImporter,
                              "DrawGEZoomToGoogleEarth");
    ClearTempFilesGE = (CLEARTEMPFILESGE)GetProcAddress(hDllImporter, "ClearTempFilesGE");
    TransformPointsOfAllGEEntities = (TRANSFORMPOINTSOFALLGEENTITIES) GetProcAddress(hDllImporter, 
                                     "TransformPointsOfAllGEEntities");

    //For other language change these texts:
    //  - texts used to define entities
    StrWCopy(GEEntLangWords.StrEntMyPlace      , _T("My Place")              , MAX_LEN_ENTITY_INFO);
    StrWCopy(GEEntLangWords.StrEntPolygonNoName, _T("Polygon - No name")     , MAX_LEN_ENTITY_INFO);
    StrWCopy(GEEntLangWords.StrEntPathNoName   , _T("Path - No name")        , MAX_LEN_ENTITY_INFO);
    StrWCopy(GEEntLangWords.StrEntGrpPtsNoName , _T("Group points - No name"), MAX_LEN_ENTITY_INFO);
    //  - texts used at drawing in Google Earth
    StrWCopy(GEKmlLangWords.StrKmlPlgNumber    , _T("Number")     , MAX_LEN_ENTITY_INFO);
    StrWCopy(GEKmlLangWords.StrKmlPathStart    , _T("Start")      , MAX_LEN_ENTITY_INFO);
    StrWCopy(GEKmlLangWords.StrKmlPathEnd      , _T("End")        , MAX_LEN_ENTITY_INFO);
    StrWCopy(GEKmlLangWords.StrKmlGrpPtsName   , _T("Group name") , MAX_LEN_ENTITY_INFO);
    StrWCopy(GEKmlLangWords.StrKmlDescription  , _T("Description"), MAX_LEN_ENTITY_INFO);
    StrWCopy(GEKmlLangWords.StrKmlArea         , _T("Area")       , MAX_LEN_ENTITY_INFO);
    StrWCopy(GEKmlLangWords.StrKmlPerimeter    , _T("Perimeter")  , MAX_LEN_ENTITY_INFO);
    StrWCopy(GEKmlLangWords.StrKmlLength       , _T("Length")     , MAX_LEN_ENTITY_INFO);
    StrWCopy(GEKmlLangWords.StrKmlInfoAd1, _T("Additional information"), MAX_LEN_ENTITY_INFO);
    StrWCopy(GEKmlLangWords.StrKmlInfoAd2, _T("Additional information"), MAX_LEN_ENTITY_INFO);
    StrWCopy(GEKmlLangWords.StrKmlInfoAd3, _T("Additional information"), MAX_LEN_ENTITY_INFO);
    StrWCopy(GEKmlLangWords.StrKmlInfoAd4, _T("Additional information"), MAX_LEN_ENTITY_INFO);
    StrWCopy(GEKmlLangWords.StrKmlInfoAd5, _T("Additional information"), MAX_LEN_ENTITY_INFO);
    StrWCopy(GEKmlLangWords.StrKmlInfoAd6, _T("Additional information"), MAX_LEN_ENTITY_INFO);
    StrWCopy(GEKmlLangWords.StrKmlInformation, _T("Information"), MAX_LEN_ENTITY_INFO);
    StrWCopy(GEKmlLangWords.StrKmlAddress      , _T("Address")    , MAX_LEN_ENTITY_INFO);
    StrWCopy(GEKmlLangWords.StrKmlDestination  , _T("Destination"), MAX_LEN_ENTITY_INFO);
    StrWCopy(GEKmlLangWords.StrKmlUsage        , _T("Usage")      , MAX_LEN_ENTITY_INFO);
    //  - texts used for folder names in Google Earth
    StrWCopy(strFoldPolygons, _T("Polygons")     , MAX_LEN_FOLDER_NAME);
    StrWCopy(strFoldPaths   , _T("Paths")        , MAX_LEN_FOLDER_NAME);
    StrWCopy(strFoldGroupPts, _T("Points Groups"), MAX_LEN_FOLDER_NAME);
    //  - text that is used to display errors about coordinate operations
    StrWCopy(strCooOpForErr  , _T("Coordinate Operation"), MAX_LEN_FOLDER_NAME);
  }
  else {
    TCHAR txt[255] = {0};
    STRCAT(txt, 255, TRLTDLLFILE);
    STRCAT(txt, 255, _T(" not loaded!"));
    MessageBox(0, (LPCTSTR)txt, (LPCTSTR)"Error", 0);
  }
}

void DllFinalization(void)
{
  if (hDllImporter)
    FreeLibrary(hDllImporter);
}

//-------------------------------------------------------------------------------------------------------------
//Useful for html colors
LPTSTR ColorToStringHtml(const unsigned char OpacityProcent, const int AColor);
LPTSTR ColorToStringHtml(const unsigned char OpacityProcent, const unsigned char Red, 
                         const unsigned char Green, const unsigned char Blue); 
void StringHtmlToColor(const LPCTSTR SColor, 
                       unsigned char *OpacityProcent, int *AColor); 
void StringHtmlToColor(const LPCTSTR SColor, 
                       unsigned char *OpacityProcent, unsigned char *Red, 
                       unsigned char *Green, unsigned char *Blue); 

//-------------------------------------------------------------------------------------------------------------
//Functions of language settings for error messages
void SetErrMsgFile(const LPCTSTR FileName);
TCHAR *GetErrMsgFile();

//-------------------------------------------------------------------------------------------------------------
//Functions about model properties read directly from mtr, mtrs or xml files (model or models files)
BOOL GetModelFileIsCompatible(const LPCTSTR lpFileName);
int  GetCountModelsFromFile(const LPCTSTR lpFileName);
BOOL GetModelHasCooOperations(const LPCTSTR lpFileName, const int ModelIndex);
BOOL GetModelIsReversible(const LPCTSTR lpFileName, const int ModelIndex);
BOOL GetModelIsCompatToDrawInGE(const LPCTSTR lpFileName, const int ModelIndex);
BOOL GetModelDescription(const LPCTSTR lpFileName, const int ModelIndex, TModelDescription *ModelDescription);

//-------------------------------------------------------------------------------------------------------------
//Final cleanup if temporary files have been created at the end of the work session
void ClearTempFiles(void)
{
  if (TempFilesIsUsed == TRUE)
    ClearTempFilesGE();
  TempFilesIsUsed = FALSE;
}

//-------------------------------------------------------------------------------------------------------------
//Class for universal coordinate transformations of points by using a TransLT transformation model.
class TTransformPoints {
  private:
    LPTSTR FlpModelFileName;
    TPlainUnits FPlainUnits;
    BOOL FUseReversed;
    LPTSTR FlpGridFilesPath;
    TModelDescription FModelDescription;
    BOOL FModelIsLoaded;
    int GetCountCooPoints();
    TAngleAspect GetAngleAspect();
  public:
    //Initialization
    TTransformPoints (const LPCTSTR lpModelFileName, const int ModelIndex, 
                      const TPlainUnits PlainUnits, const BOOL UseReversed, 
                      const LPCTSTR lpGridFilesPath);
    //Finalization
    virtual ~TTransformPoints();

    void SetModelFile(const LPCTSTR lpModelFileName, const int ModelIndex, 
                      const TPlainUnits PlainUnits, const BOOL UseReversed, 
                      const LPCTSTR lpGridFilesPath);
    void AddCooPoint (const LPCTSTR lpPntName, 
                      const double XorEorPhi, const double YorNorLam, const double ZorHorHe, 
                      const LPCTSTR lpPntCode);
    void SetCooPoint (const int Index, 
                      const LPCTSTR lpPntName, 
                      const double XorEorPhi, const double YorNorLam, const double ZorHorHe, 
                      const LPCTSTR lpPntCode);
    BOOL GetCooPoint (const int Index, 
                      LPTSTR *lpPntName, 
                      double *XorEorPhi, double *YorNorLam, double *ZorHorHe, 
                      LPTSTR *lpPntCode);
    BOOL GetCooPointFormated(const int Index, 
                             LPTSTR *lpPntName, 
                             LPTSTR *lpStrXorEorPhi, LPTSTR *lpStrYorNorLam, LPTSTR *lpStrZorHorHe, 
                             LPTSTR *lpPntCode);
    void DeleteCooPoint(const int Index);
    void DeleteAllCooPoint();
    BOOL LoadCooPointsFromFile(const LPCTSTR lpFileName);
    BOOL SaveCooPointsToFile(const LPCTSTR lpFileName, 
                             const BOOL FixCoo,
                             const TEncodingType EncodingType);
    BOOL ApplyTransformation(TProgressProc ProgressProc, const BOOL Silent = FALSE);

    //Properties about model
    LPTSTR            get_ModelFileName()    { return FlpModelFileName; }
    TPlainUnits       get_PlainUnits()       { return FPlainUnits; }
    BOOL              get_UseReversed()      { return FUseReversed; }
    LPTSTR            get_GridFilesPath()    { return FlpGridFilesPath; }
    TModelDescription get_ModelDescription() { return FModelDescription; }
    BOOL              get_ModelIsLoaded()    { return FModelIsLoaded; }
    BOOL              get_IsTimeDependent()  { return FModelDescription.IsTimeDependent; }
    BOOL              get_IsUseTimeEpochT0() { return FModelDescription.IsUseTimeEpochT0; }
    double            get_EpochT0()          { double rslt; if (GetTrPntEpochT0(&rslt) == FALSE) rslt = 0.0; return rslt; }
    double            get_EpochT()           { double rslt; if (GetTrPntEpochT(&rslt) == FALSE) rslt = 0.0; return rslt; }
    void              set_EpochT0(double v)  { SetTrPntEpochT0(v); }
    void              set_EpochT(double v)   { SetTrPntEpochT(v); }

    //Properties about points
    int get_CountCooPoints()                 { return GetCountCooPoints(); }

    //Values used only at read and write coordinates from file
    #ifdef UNICODE
      wchar_t ChDeg;
      wchar_t ChMin;
      wchar_t ChSec;
    #else
      unsigned char ChDeg;
      unsigned char ChMin;
      unsigned char ChSec;
    #endif
    TCHAR ChCsv;
    BOOL UseDecDeg;
    BOOL UseNSEW;
    int DecNoXYZ;
    int DecNoNEH;
    int DecNoSec;
    int DecNoGeoHe;
    BOOL InvertAxes12;
};

//-------------------------------------------------------------------------------------------------------------
//Class for universal coordinate transformations of points of entities by using a TransLT transformation model 
//and for drawing entities in Google Earth. Entities are drawn only in 2D dimension and are represented in
//Google Earth at the ground level.
class TTransformEntitiesGE {
  private:
    LPTSTR FlpModelFileName;
    TPlainUnits FPlainUnits;
    TAreaUnits FAreaUnits;
    TPlainUnits FLengthUnits;
    BOOL FUseReversed;
    LPTSTR FlpGridFilesPath;
    TModelDescription FModelDescription;
    TGEDrawOptions FGEDrawOptions;
    BOOL FModelIsLoaded;
    LPTSTR FlpPlaceName;
    TAngleAspect GetAngleAspect();
  public:
    //Initialization
    TTransformEntitiesGE(const LPCTSTR lpModelFileName, const int ModelIndex, 
                         const TPlainUnits PlainUnits, const BOOL UseReversed, 
                         const LPCTSTR lpGridFilesPath);
    //Finalization
    virtual ~TTransformEntitiesGE();

    void SetModelFile(const LPCTSTR lpModelFileName, const int ModelIndex, 
                      const TPlainUnits PlainUnits, const BOOL UseReversed, 
                      const LPCTSTR lpGridFilesPath);

    void AddEntity(TGEEntityProperties GEEntityProperties);
    void SetEntity(const int EntIndex, 
                   TGEEntityProperties GEEntityProperties);
    void DeleteEntity(const int EntIndex);
    BOOL GetEntity(const int EntIndex, 
                   TGEEntityProperties *GEEntityProperties);
    void ClearEntities();
    int GetCountEntites();
    void AddPointToEntity(const int EntIndex, 
                          const LPCTSTR lpPntName, 
                          const double EorPhi, const double NorLam);
    void SetPointToEntity(const int EntIndex, const int PntIndex, 
                          const LPCTSTR lpPntName, 
                          const double EorPhi, const double NorLam);
    BOOL GetPointFromEntity(const int EntIndex, const int PntIndex, 
                            LPTSTR *lpPntName, 
                            double *EorPhi, double *NorLam);
    BOOL GetPointFromEntityFormated(const int EntIndex, const int PntIndex, 
                                    LPTSTR *lpPntName, 
                                    LPTSTR *lpStrEorPhi, LPTSTR *lpStrNorLam, 
                                    const BOOL CoordIsGeog);
    int GetCountPointsOfEntity(const int EntIndex);
    void DeleteAllPointsOfEntity(const int EntIndex);
    void CalculateAreaAndLengthToEntity(const int EntIndex);
    BOOL LoadEntitiesFromFile(const LPCTSTR lpFileName);
    BOOL SaveEntitiesToFile(const LPCTSTR lpFileName, 
                            const TEncodingType EncodingType);
    BOOL DrawEntitiesToGoogleEarth(const LPCTSTR lpTempFileName = NULL);
    BOOL SaveZoomToFile(const LPCTSTR lpFileName, const LPCTSTR lpFolderName,
                        const double PhiMin, const double LamMin, 
                        const double PhiMax, const double LamMax);
    BOOL DrawZoomToGoogleEarth(const double PhiMin, const double LamMin,
                               const double PhiMax, const double LamMax,
                               const LPCTSTR lpFolderName = NULL,
                               const LPCTSTR lpTempFileName = NULL);
    BOOL TransformPointsOfAllEntities(TProgressProc ProgressProc);

    //Properties about model
    LPTSTR            get_ModelFileName()    { return FlpModelFileName; }
    TPlainUnits       get_PlainUnits()       { return FPlainUnits; }
    BOOL              get_UseReversed()      { return FUseReversed; }
    LPTSTR            get_GridFilesPath()    { return FlpGridFilesPath; }
    TModelDescription get_ModelDescription() { return FModelDescription; }
    BOOL              get_ModelIsLoaded()    { return FModelIsLoaded; }
    BOOL              get_IsTimeDependent()  { return FModelDescription.IsTimeDependent; }
    BOOL              get_IsUseTimeEpochT0() { return FModelDescription.IsUseTimeEpochT0; }
    double            get_EpochT0()          { double rslt; if (GetTrGEEpochT0(&rslt) == FALSE) rslt = 0.0; return rslt; }
    double            get_EpochT()           { double rslt; if (GetTrGEEpochT(&rslt) == FALSE) rslt = 0.0; return rslt; }
    void              set_EpochT0(double v)  { SetTrGEEpochT0(v); }
    void              set_EpochT(double v)   { SetTrGEEpochT(v); }

    //Drawing properties in Google Earth 
    TGEDrawOptions    get_GEDrawOptions()    { return FGEDrawOptions; };
    void              set_GEDrawOptions(TGEDrawOptions v);

    //Values used only at read and write coordinates from file
    #ifdef UNICODE
      wchar_t ChDeg;
      wchar_t ChMin;
      wchar_t ChSec;
    #else
      unsigned char ChDeg;
      unsigned char ChMin;
      unsigned char ChSec;
    #endif
    TCHAR ChCsv;
    BOOL UseDecDeg;
    BOOL UseNSEW;
    int DecNoNEH;
    int DecNoSec;
    BOOL InvertAxes12;
    int DecNoArea;
    int DecNoLength;
    TAreaUnits AreaUnits;
    TPlainUnits LengthUnits;
    LPTSTR ProgName;
    LPTSTR ProgVer;
    LPTSTR WebPage;
    LPTSTR get_PlaceName() { return FlpPlaceName; }
     void  set_PlaceName(const LPCTSTR Value);
};

//-------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------
LPSTR StrWtoMB(LPWSTR Source, int nLength)
{
  //Only for NULL terminated string
  int sizeNeeded = WideCharToMultiByte(CP_ACP, 0, Source, nLength, NULL, 0,  NULL, NULL);
  LPSTR Dest = (char *)malloc((sizeNeeded+1)*sizeof(char));
  WideCharToMultiByte(CP_ACP, 0, Source, -1, Dest, sizeNeeded, NULL, NULL);
  Dest[sizeNeeded] = '\0';
  return Dest;
}

//-------------------------------------------------------------------------------------------------------------
LPWSTR StrMBtoW(const LPCSTR Source)
{
  //Only for NULL terminated string
  int sizeNeeded = MultiByteToWideChar(CP_ACP, 0, Source, -1, NULL, 0);
  LPWSTR Dest = (wchar_t *)malloc((sizeNeeded)*sizeof(wchar_t));
  MultiByteToWideChar(CP_ACP, 0, Source, -1, Dest, sizeNeeded);
  return Dest;
}

//-------------------------------------------------------------------------------------------------------------
void StrWCopy(LPWSTR Dest, const LPCTSTR Source, int MaxLen)
{ 
  int i, Len;
  Len = (int)TLstrlen(Source);
  if (Len > MaxLen) Len = MaxLen;
  for(i = 0; i < Len ; ++i)
    Dest[i] = Source[i];
  Dest[Len] = '\0';
}

//-------------------------------------------------------------------------------------------------------------

#ifndef UNICODE
void StrWCopy(LPSTR Dest, const LPCTSTR Source, int MaxLen)
{ 
  int i, Len;
  Len = (int)TLstrlen(Source);
  if (Len > MaxLen) Len = MaxLen;
  for(i = 0; i < Len ; ++i)
    Dest[i] = Source[i];
  Dest[Len] = '\0';
}
#endif

//-------------------------------------------------------------------------------------------------------------
LPTSTR StrSetAndWCopy(const LPCTSTR Source)
{
  int Len = (int)TLstrlen(Source) + 1;
  LPTSTR Dest = (TCHAR *)malloc(Len*sizeof(TCHAR));
  StrWCopy(Dest, Source, Len);
  return Dest;
}

//-------------------------------------------------------------------------------------------------------------
LPCWSTR StrTCharToWChar(const LPCTSTR Source)
{
  #ifdef UNICODE
    return Source;
  #else
    return StrMBtoW(Source);
  #endif
}

//-------------------------------------------------------------------------------------------------------------
void ChangeToAnsiPhiLambdaAndArrows(LPWSTR lpWText, const int MaxLen)
{ 
  int i, Len;
  wchar_t S[2048] = {0};
  wchar_t ch[2];
  LPCWSTR ChPhi = StrTCharToWChar(CH_PHI);
  LPCWSTR ChLam = StrTCharToWChar(CH_LAMBDA);

  Len = (int)wcslen(lpWText);
  if (Len > 0) {
    ch[1] = '\0';
    for(i = 0; i < Len ; ++i) {
      if (lpWText[i] == L'\x03C6') //Greek Small Letter Phi
        WCSCAT(S, 2048, ChPhi);
      else
      if (lpWText[i] == L'\x03BB') //Greek Small Letter Lambda
        WCSCAT(S, 2048, ChLam);
      else
      if (lpWText[i] == L'\x2190') //Leftwards Arrow
        WCSCAT(S, 2048, L"<-");
      else
      if (lpWText[i] == L'\x2192') //Rightwards Arrow
        WCSCAT(S, 2048, L"->");
      else
      if (lpWText[i] == L'\x2194') //Left Right Arrow
        WCSCAT(S, 2048, L"<->");
      else
      if (lpWText[i] == L'\x21C4') //Rightwards Arrow Over Leftwards Arrow
        WCSCAT(S, 2048, L"<->");
      else {
        ch[0] = lpWText[i];
        WCSCAT(S, 2048, ch);
      }
    }
    Len = (int)wcslen(S);
    if (Len > MaxLen) Len = MaxLen;
    MEMCPY(lpWText, MaxLen*sizeof(wchar_t), S, Len*sizeof(wchar_t));
    lpWText[Len] = '\0';
  }
}

//-------------------------------------------------------------------------------------------------------------
void ChangeCharsOfModelDescription(TModelDescription *ModelDescription)
{
  ChangeToAnsiPhiLambdaAndArrows(ModelDescription->ModelName       , MAX_LEN_NAMES);
  ChangeToAnsiPhiLambdaAndArrows(ModelDescription->TransDescription, MAX_LEN_NAMES);
  ChangeToAnsiPhiLambdaAndArrows(ModelDescription->CooSysIniName   , MAX_LEN_NAMES);
  ChangeToAnsiPhiLambdaAndArrows(ModelDescription->CooSysFinName   , MAX_LEN_NAMES);
}

//-------------------------------------------------------------------------------------------------------------
BOOL LibBoolToBool(const BOOL b)
{ 
  if (b != FALSE)  // b <> 0, b = -1 
    return TRUE;   // return 1
  else
    return FALSE;  // return 0
}

//-------------------------------------------------------------------------------------------------------------
void ShowMessageError(const int ErrNo, 
                      const LPWSTR lpErrTxt, int nMaxCount)
{
  TCHAR ErrTxt[1024];
  #ifdef UNICODE
    SPRINTF(ErrTxt, _T("Error Number: %d (line number from .err text file)\nText Message: \n________________________________________________________\n\n%s"), 
      ErrNo, lpErrTxt);
  #else
      wchar_t WErrTxt[1024];
      TLwcsncpy(WErrTxt, lpErrTxt, 1024);
      ChangeToAnsiPhiLambdaAndArrows(WErrTxt, 512);
      nMaxCount = (int)wcslen(WErrTxt);

      SPRINTF(ErrTxt, _T("Error Number: %d (line number from .err text file)\nText Message: \n________________________________________________________\n\n%s"), 
      ErrNo, StrWtoMB(WErrTxt, nMaxCount));
  #endif
  MessageBox(NULL, ErrTxt, _T("Error"), MB_OK);
}

//-------------------------------------------------------------------------------------------------------------
//----------------------------------------------- Html colors -------------------------------------------------
//-------------------------------------------------------------------------------------------------------------
int GetColorFromStringHtml(const LPCTSTR SColor)
{
  if (TLstrlen(SColor) >= MAX_LEN_HTML_COLOR) {
    TCHAR *p, cl[MAX_LEN_HTML_COLOR+1];
    TLstrcpy(cl, SColor, MAX_LEN_HTML_COLOR);
    cl[0] = '0';
    cl[1] = '0';
    return (int)TLstrtol(cl, &p, 16);
  }
  else return 0;
}

//-------------------------------------------------------------------------------------------------------------
unsigned char GetOpacityProcentFromStringHtml(const LPCTSTR SColor)
{   
  unsigned char Opacity = 255;
  if (TLstrlen(SColor) >= 2) {
    TCHAR *p, op[3];
    TLstrcpy(op, SColor, 2);
    Opacity = (int)TLstrtol(op, &p, 16);
  }
  return (int)(100*(Opacity*1.0/255) + 0.5);
}

//-------------------------------------------------------------------------------------------------------------
LPTSTR ColorToStringHtml(const unsigned char OpacityProcent, const int AColor)
{
  TCHAR rslt[MAX_LEN_HTML_COLOR+1];
  unsigned char Opacity;
  Opacity = (int)(255*OpacityProcent/100);
  SPRINTF_S(rslt, MAX_LEN_HTML_COLOR+1, _T("%.2x%.6x"), Opacity, AColor);
  return TLstrdup(rslt);
}

//-------------------------------------------------------------------------------------------------------------
LPTSTR ColorToStringHtml(const unsigned char OpacityProcent, const unsigned char Red, 
                         const unsigned char Green, const unsigned char Blue)
{
  return ColorToStringHtml(OpacityProcent, RGB(Red, Green, Blue));
}

//-------------------------------------------------------------------------------------------------------------
void StringHtmlToColor(const LPCTSTR SColor, 
                       unsigned char *OpacityProcent, int *AColor) 
{
  *OpacityProcent = GetOpacityProcentFromStringHtml(SColor);
  *AColor = GetColorFromStringHtml(SColor);
}

//-------------------------------------------------------------------------------------------------------------
void StringHtmlToColor(const LPCTSTR SColor, 
                        unsigned char *OpacityProcent, unsigned char *Red, 
                        unsigned char *Green, unsigned char *Blue) 
{
  int AColor;
  StringHtmlToColor(SColor, OpacityProcent, &AColor);
  *Red   = GetRValue(AColor);
  *Green = GetGValue(AColor);
  *Blue  = GetBValue(AColor);
}

//-------------------------------------------------------------------------------------------------------------
//----------------------------------- Settings for error messages ---------------------------------------------
//-------------------------------------------------------------------------------------------------------------
void SetErrMsgFile(const LPCTSTR FileName)
{
  SetErrMsgFileName(StrTCharToWChar(FileName));
}

//-------------------------------------------------------------------------------------------------------------
TCHAR *GetErrMsgFile()
{
  int nMaxCount;
  LPWSTR lpFileName;
  GetErrMsgFileName(&lpFileName, &nMaxCount);
  #ifdef UNICODE
    return TLstrdup(lpFileName);
  #else
    return StrWtoMB(lpFileName, nMaxCount);
  #endif
}

//-------------------------------------------------------------------------------------------------------------
//---------------------------------- Model properties from file -----------------------------------------------
//-------------------------------------------------------------------------------------------------------------
BOOL GetModelFileIsCompatible(const LPCTSTR lpFileName)
{
  return LibBoolToBool(ModelFileIsCompatible(StrTCharToWChar(lpFileName)));
}

//-------------------------------------------------------------------------------------------------------------
int  GetCountModelsFromFile(const LPCTSTR lpFileName)
{
  return GetCountModels(StrTCharToWChar(lpFileName));
}

//-------------------------------------------------------------------------------------------------------------
BOOL GetModelHasCooOperations(const LPCTSTR lpFileName, const int ModelIndex)
{
  BOOL rslt;
  int ErrNo, nMaxCount;
  LPWSTR lpErrTxt;

  rslt = LibBoolToBool(ModelHasCooOperations(StrTCharToWChar(lpFileName), ModelIndex, &ErrNo, &lpErrTxt, &nMaxCount));
  if (ErrNo > 0)
    ShowMessageError(ErrNo, lpErrTxt, nMaxCount);

  return rslt;
}

//-------------------------------------------------------------------------------------------------------------
BOOL GetModelIsReversible(const LPCTSTR lpFileName, const int ModelIndex)
{
  BOOL rslt;
  int ErrNo, nMaxCount;
  LPWSTR lpErrTxt;

  rslt = LibBoolToBool(ModelIsReversible(StrTCharToWChar(lpFileName), ModelIndex, &ErrNo, &lpErrTxt, &nMaxCount));

  if (ErrNo > 0)
    ShowMessageError(ErrNo, lpErrTxt, nMaxCount);

  return rslt;
}

//-------------------------------------------------------------------------------------------------------------
BOOL GetModelIsCompatToDrawInGE(const LPCTSTR lpFileName, const int ModelIndex)
{
  BOOL rslt;
  int ErrNo, nMaxCount;
  LPWSTR lpErrTxt;

  rslt = LibBoolToBool(ModelIsCompatibleToDrawInGoogleEarth(StrTCharToWChar(lpFileName), ModelIndex, 
       &ErrNo, &lpErrTxt, &nMaxCount));

  if (ErrNo > 0)
    ShowMessageError(ErrNo, lpErrTxt, nMaxCount);

  return rslt;
}

//-------------------------------------------------------------------------------------------------------------
BOOL GetModelDescription(const LPCTSTR lpFileName, const int ModelIndex, TModelDescription *ModelDescription)
{
  BOOL rslt;
  int ErrNo, nMaxCount;
  LPWSTR lpErrTxt;

  rslt = LibBoolToBool(GetModelDescriptionFromFile(StrTCharToWChar(lpFileName), ModelIndex, ModelDescription, 
         &ErrNo, &lpErrTxt, &nMaxCount));

  ModelDescription->SupportReverseCalc = LibBoolToBool(ModelDescription->SupportReverseCalc);
  ModelDescription->IsTimeDependent = LibBoolToBool(ModelDescription->IsTimeDependent);
  ModelDescription->IsUseTimeEpochT0 = LibBoolToBool(ModelDescription->IsUseTimeEpochT0);

  if (ErrNo > 0)
    ShowMessageError(ErrNo, lpErrTxt, nMaxCount);
  else {
    #ifndef UNICODE
      ChangeCharsOfModelDescription(ModelDescription);
    #endif
  }

  return rslt;
}

//-------------------------------------------------------------------------------------------------------------
//------------------------------------------- TTransformPoints ------------------------------------------------
//-------------------------------------------------------------------------------------------------------------
TTransformPoints::TTransformPoints(const LPCTSTR lpModelFileName, const int ModelIndex, 
                                   const TPlainUnits PlainUnits, const BOOL UseReversed, 
                                   const LPCTSTR lpGridFilesPath)
{
  ChDeg = 176;  // = 
  ChMin = '\'';
  ChSec = '"';

  //Load list separators from Window locale settings
  TCHAR s[4] = {0};
  GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SLIST, &s[0], 4);
  ChCsv = s[0]; 

  UseDecDeg = FALSE;
  UseNSEW = TRUE;
  DecNoXYZ = 4;
  DecNoNEH = 3;
  DecNoSec = 6;
  DecNoGeoHe = 3;
  InvertAxes12 = FALSE;

  SetModelFile(lpModelFileName, ModelIndex, PlainUnits, UseReversed, lpGridFilesPath);
}

//-------------------------------------------------------------------------------------------------------------
TTransformPoints::~TTransformPoints()
{
  DoneTrPntModel();
}

//-------------------------------------------------------------------------------------------------------------
void TTransformPoints::SetModelFile(const LPCTSTR lpModelFileName, const int ModelIndex, 
                                    const TPlainUnits PlainUnits, const BOOL UseReversed, 
                                    const LPCTSTR lpGridFilesPath)
{
  int ErrNo, nMaxCount;
  LPWSTR lpErrTxt;

  memset(&FModelDescription, 0, sizeof(TModelDescription));

  FlpModelFileName = _T("");
  FPlainUnits = PlainUnits;
  FUseReversed = UseReversed;
  FlpGridFilesPath = _T("");
  FModelIsLoaded = FALSE;

  if (LibBoolToBool(InitTrPntModel(StrTCharToWChar(lpModelFileName), StrTCharToWChar(lpGridFilesPath), ModelIndex, 
      FPlainUnits, UseReversed, &ErrNo, &lpErrTxt, &nMaxCount)) == TRUE) {
    if (LibBoolToBool(GetTrPntModelDescription(&FModelDescription)) == TRUE) {
      FModelIsLoaded = TRUE;
      FlpModelFileName = StrSetAndWCopy(lpModelFileName);
      FlpGridFilesPath = StrSetAndWCopy(lpGridFilesPath);
      FModelDescription.SupportReverseCalc = LibBoolToBool(FModelDescription.SupportReverseCalc);
      FModelDescription.IsTimeDependent = LibBoolToBool(FModelDescription.IsTimeDependent);
      FModelDescription.IsUseTimeEpochT0 = LibBoolToBool(FModelDescription.IsUseTimeEpochT0);

      #ifndef UNICODE
        ChangeCharsOfModelDescription(&FModelDescription);
      #endif
    }
  }
  else {
    if (ErrNo > 0)
      ShowMessageError(ErrNo, lpErrTxt, nMaxCount);
  }
}

//-------------------------------------------------------------------------------------------------------------
void TTransformPoints::AddCooPoint(const LPCTSTR lpPntName, 
                                   const double XorEorPhi, 
                                   const double YorNorLam, 
                                   const double ZorHorHe, 
                                   const LPCTSTR lpPntCode)
{
  AddPoint(StrTCharToWChar(lpPntName), XorEorPhi, YorNorLam, ZorHorHe, StrTCharToWChar(lpPntCode));
}

//-------------------------------------------------------------------------------------------------------------
void TTransformPoints::SetCooPoint(const int Index, 
                                   const LPCTSTR lpPntName, 
                                   const double XorEorPhi, 
                                   const double YorNorLam, 
                                   const double ZorHorHe, 
                                   const LPCTSTR lpPntCode)
{
  SetPoint(Index, StrTCharToWChar(lpPntName), XorEorPhi, YorNorLam, ZorHorHe, StrTCharToWChar(lpPntCode));
}

//-------------------------------------------------------------------------------------------------------------
BOOL TTransformPoints::GetCooPoint(const int Index, 
                                   LPTSTR *lpPntName, 
                                   double *XorEorPhi, double *YorNorLam, double *ZorHorHe, 
                                   LPTSTR *lpPntCode)
{   
  int nMaxPntNameCount, nMaxPntCodeCount;
  #ifdef UNICODE
    return LibBoolToBool(GetPoint(Index, lpPntName, &nMaxPntNameCount,
                                         XorEorPhi, YorNorLam, ZorHorHe,
                                         lpPntCode, &nMaxPntCodeCount));
  #else
    BOOL rslt;
    LPWSTR PntName, PntCode;
    rslt = LibBoolToBool(GetPoint(Index, &PntName, &nMaxPntNameCount,
                                         XorEorPhi, YorNorLam, ZorHorHe,
                                         &PntCode, &nMaxPntCodeCount));
    *lpPntName = StrWtoMB(PntName, nMaxPntNameCount);
    *lpPntCode = StrWtoMB(PntCode, nMaxPntCodeCount);
    return rslt;
  #endif
}

//-------------------------------------------------------------------------------------------------------------
BOOL TTransformPoints::GetCooPointFormated(const int Index, 
                                           LPTSTR *lpPntName, 
                                           LPTSTR *lpStrXorEorPhi, LPTSTR *lpStrYorNorLam, LPTSTR *lpStrZorHorHe, 
                                           LPTSTR *lpPntCode)
{ 
  int nMaxPntNameCount, nMaxXorEorPhiCount, nMaxYorNorLamCount, nMaxZorHorHeCount, nMaxPntCodeCount;
  #ifdef UNICODE
    return LibBoolToBool(GetPointFormated(Index, lpPntName, &nMaxPntNameCount,
                                                 lpStrXorEorPhi, &nMaxXorEorPhiCount,
                                                 lpStrYorNorLam, &nMaxYorNorLamCount,
                                                 lpStrZorHorHe, &nMaxZorHorHeCount,
                                                 lpPntCode, &nMaxPntCodeCount,
                                                 &GetAngleAspect(),
                                                 DecNoXYZ, DecNoNEH, DecNoGeoHe));
  #else
    BOOL rslt;
    LPWSTR PntName, StrXorEorPhi, StrYorNorLam, StrZorHorHe, PntCode;
    rslt = LibBoolToBool(GetPointFormated(Index, &PntName, &nMaxPntNameCount,
                                                 &StrXorEorPhi, &nMaxXorEorPhiCount,
                                                 &StrYorNorLam, &nMaxYorNorLamCount,
                                                 &StrZorHorHe, &nMaxZorHorHeCount,
                                                 &PntCode, &nMaxPntCodeCount,
                                                 &GetAngleAspect(),
                                                 DecNoXYZ, DecNoNEH, DecNoGeoHe));
    *lpPntName      = StrWtoMB(PntName, nMaxPntNameCount);
    *lpStrXorEorPhi = StrWtoMB(StrXorEorPhi, nMaxXorEorPhiCount);
    *lpStrYorNorLam = StrWtoMB(StrYorNorLam, nMaxYorNorLamCount);
    *lpStrZorHorHe  = StrWtoMB(StrZorHorHe, nMaxZorHorHeCount);
    *lpPntCode      = StrWtoMB(PntCode, nMaxPntCodeCount);
    return rslt;
  #endif
}

//-------------------------------------------------------------------------------------------------------------
void TTransformPoints::DeleteCooPoint(const int Index)
{
  DeletePoint(Index);
}

//-------------------------------------------------------------------------------------------------------------
void TTransformPoints::DeleteAllCooPoint()
{
  DeleteAllPoints;
}

//-------------------------------------------------------------------------------------------------------------
int TTransformPoints::GetCountCooPoints()
{
  return GetCountPoints();
}

//-------------------------------------------------------------------------------------------------------------
TAngleAspect TTransformPoints::GetAngleAspect()
{   
  TAngleAspect rslt;
  rslt.UseDecDeg = UseDecDeg;
  rslt.UseNSEW   = UseNSEW;
  rslt.ChDeg     = ChDeg;
  rslt.ChMin     = ChMin;
  rslt.ChSec     = ChSec;
  rslt.DecNoSec  = DecNoSec;
  return rslt;
}

//-------------------------------------------------------------------------------------------------------------
BOOL TTransformPoints::LoadCooPointsFromFile(const LPCTSTR lpFileName)
{   
  BOOL rslt;
  int ErrNo, nMaxCount;
  LPWSTR lpErrTxt;

  rslt = LibBoolToBool(LoadPointsFromFile(StrTCharToWChar(lpFileName), InvertAxes12, &GetAngleAspect(), 
	                                      FPlainUnits, ChCsv, &ErrNo, &lpErrTxt, &nMaxCount)); 

  if ((rslt == FALSE) && (ErrNo > 0))
    ShowMessageError(ErrNo, lpErrTxt, nMaxCount);

  return rslt;
}

//-------------------------------------------------------------------------------------------------------------
BOOL TTransformPoints::SaveCooPointsToFile(const LPCTSTR lpFileName, 
                                           const BOOL FixCoo,
                                           const TEncodingType EncodingType)
{
  return LibBoolToBool(SavePointsToFile(StrTCharToWChar(lpFileName), FixCoo, InvertAxes12, &GetAngleAspect(), 
	                                    FPlainUnits, ChCsv, DecNoXYZ, DecNoNEH, DecNoGeoHe, EncodingType));
}

//-------------------------------------------------------------------------------------------------------------
BOOL TTransformPoints::ApplyTransformation(TProgressProc ProgressProc, const BOOL Silent)
{ 
  BOOL rslt;
  int ErrNo, nMaxCount;
  LPWSTR lpErrTxt;

  rslt = LibBoolToBool(TransformPoints(ProgressProc, strCooOpForErr, &ErrNo, &lpErrTxt, &nMaxCount));

  if ((rslt == FALSE) && (ErrNo > 0) && (Silent == FALSE))
    ShowMessageError(ErrNo, lpErrTxt, nMaxCount);
  
  return rslt;
}

//-------------------------------------------------------------------------------------------------------------
//------------------------------------------- TTransformEntitiesGE --------------------------------------------
//-------------------------------------------------------------------------------------------------------------
TTransformEntitiesGE::TTransformEntitiesGE(const LPCTSTR lpModelFileName, const int ModelIndex, 
                                           const TPlainUnits PlainUnits, const BOOL UseReversed, 
                                           const LPCTSTR lpGridFilesPath)
{
  ChDeg = 176;  // = 
  ChMin = '\'';
  ChSec = '"';

  //Load list separators from Window locale settings
  TCHAR s[4] = {0};
  GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SLIST, &s[0], 4);
  ChCsv = s[0]; 

  UseDecDeg = FALSE;
  UseNSEW = TRUE;
  DecNoNEH = 3;
  DecNoSec = 6;
  InvertAxes12 = FALSE;

  DecNoArea = 2;
  DecNoLength = 2;
  FAreaUnits = auSqMeter;
  FLengthUnits = puMeter;

  ProgName = StrSetAndWCopy(_T("My Application"));
  ProgVer  = StrSetAndWCopy(_T("1.0"));
  WebPage  = StrSetAndWCopy(_T("http://_my_page_.com"));
  FlpPlaceName = StrSetAndWCopy(MY_PLACE_INI_TEXT);

  StrWCopy(FGEDrawOptions.PlgLabelsHtmlColor, ColorToStringHtml(100, 255, 170, 0), MAX_LEN_HTML_COLOR);
  StrWCopy(FGEDrawOptions.PlgLinesHtmlColor,  ColorToStringHtml(100, 65535), MAX_LEN_HTML_COLOR); //clYelow = 65535;
  FGEDrawOptions.PlgDrawLabels = TRUE;
  FGEDrawOptions.PlgAddAreaToName = FALSE;
  StrWCopy(FGEDrawOptions.PathLabelsHtmlColor, _T("ffb88774"), MAX_LEN_HTML_COLOR);
  FGEDrawOptions.PathDrawLabels = TRUE;
  FGEDrawOptions.PathAddLengthToName = TRUE;
  FGEDrawOptions.PathIdxSymbIcon = 0;
  StrWCopy(FGEDrawOptions.PtsLabelsHtmlColor, _T("ffffffff"), MAX_LEN_HTML_COLOR);
  FGEDrawOptions.AddDescrToName = TRUE;
  FGEDrawOptions.LabelsDistToViewKm = 10.0;  //km
  StrWCopy(FGEDrawOptions.FoldPlg   , strFoldPolygons, MAX_LEN_FOLDER_NAME);
  StrWCopy(FGEDrawOptions.FoldPath  , strFoldPaths   , MAX_LEN_FOLDER_NAME);
  StrWCopy(FGEDrawOptions.FoldGrpPts, strFoldGroupPts, MAX_LEN_FOLDER_NAME);
  FGEDrawOptions.CorPhi = 0.0;   //Be careful when changing
  FGEDrawOptions.CorLam = 0.0;   //these values.

  SetModelFile(lpModelFileName, ModelIndex, PlainUnits, UseReversed, lpGridFilesPath);
}

//-------------------------------------------------------------------------------------------------------------
TTransformEntitiesGE::~TTransformEntitiesGE()
{
  DoneTrGEModel();
}

//-------------------------------------------------------------------------------------------------------------
void TTransformEntitiesGE::set_PlaceName(const LPCTSTR Value)
{
  if (TLstrlen(Value) == 0)  
    FlpPlaceName = StrSetAndWCopy(MY_PLACE_INI_TEXT);
  else
    FlpPlaceName = StrSetAndWCopy(Value);
}

//-------------------------------------------------------------------------------------------------------------
TAngleAspect TTransformEntitiesGE::GetAngleAspect()
{   
  TAngleAspect rslt;
  rslt.UseDecDeg = UseDecDeg;
  rslt.UseNSEW   = UseNSEW;
  rslt.ChDeg     = ChDeg;
  rslt.ChMin     = ChMin;
  rslt.ChSec     = ChSec;
  rslt.DecNoSec  = DecNoSec;
  return rslt;
}

//-------------------------------------------------------------------------------------------------------------
void TTransformEntitiesGE::SetModelFile(const LPCTSTR lpModelFileName, const int ModelIndex, 
                                        const TPlainUnits PlainUnits, const BOOL UseReversed, 
                                        const LPCTSTR lpGridFilesPath)
{
  int ErrNo, nMaxCount;
  LPWSTR lpErrTxt;

  memset(&FModelDescription, 0, sizeof(TModelDescription));

  FlpModelFileName = _T("");
  FPlainUnits = PlainUnits;
  FUseReversed = UseReversed;
  FlpGridFilesPath = _T("");
  FModelIsLoaded = FALSE;

  if (LibBoolToBool(InitTrGEModel(StrTCharToWChar(lpModelFileName), StrTCharToWChar(lpGridFilesPath), ModelIndex, 
      FPlainUnits, UseReversed, &GEEntLangWords, &ErrNo, &lpErrTxt, &nMaxCount)) == TRUE) {
    if (LibBoolToBool(GetTrGEModelDescription(&FModelDescription)) == TRUE) {
      FModelIsLoaded = TRUE;
      FlpModelFileName = StrSetAndWCopy(lpModelFileName);
      FlpGridFilesPath = StrSetAndWCopy(lpGridFilesPath);
      FModelDescription.SupportReverseCalc = LibBoolToBool(FModelDescription.SupportReverseCalc);
      FModelDescription.IsTimeDependent = LibBoolToBool(FModelDescription.IsTimeDependent);
      FModelDescription.IsUseTimeEpochT0 = LibBoolToBool(FModelDescription.IsUseTimeEpochT0);

      #ifndef UNICODE
        ChangeCharsOfModelDescription(&FModelDescription);
      #endif
    }
  }
  else {
    if (ErrNo > 0)
      ShowMessageError(ErrNo, lpErrTxt, nMaxCount);
  }
}

//-------------------------------------------------------------------------------------------------------------
void TTransformEntitiesGE::AddEntity(TGEEntityProperties GEEntityProperties)
{
  AddGEEntity(&GEEntityProperties);
}

//-------------------------------------------------------------------------------------------------------------
void TTransformEntitiesGE::SetEntity(const int EntIndex, 
                                     TGEEntityProperties GEEntityProperties)
{
  SetGEEntity(EntIndex, &GEEntityProperties);
}

//-------------------------------------------------------------------------------------------------------------
void TTransformEntitiesGE::DeleteEntity(const int EntIndex)
{
  DeleteGEEntity(EntIndex);
}

//-------------------------------------------------------------------------------------------------------------
BOOL TTransformEntitiesGE::GetEntity(const int EntIndex, 
                                     TGEEntityProperties *GEEntityProperties)
{
  return LibBoolToBool(GetGEEntity(EntIndex, GEEntityProperties));
  GEEntityProperties->UseAddBox   = LibBoolToBool(GEEntityProperties->UseAddBox);
  GEEntityProperties->UseAddInfo1 = LibBoolToBool(GEEntityProperties->UseAddInfo1);
  GEEntityProperties->UseAddInfo2 = LibBoolToBool(GEEntityProperties->UseAddInfo2);
  GEEntityProperties->UseAddInfoA = LibBoolToBool(GEEntityProperties->UseAddInfoA);
  GEEntityProperties->UseAddInfoL = LibBoolToBool(GEEntityProperties->UseAddInfoL);
  GEEntityProperties->UseAddAdr   = LibBoolToBool(GEEntityProperties->UseAddAdr);
  GEEntityProperties->UseAddDest  = LibBoolToBool(GEEntityProperties->UseAddDest);
  GEEntityProperties->UseAddUsage = LibBoolToBool(GEEntityProperties->UseAddUsage);
  GEEntityProperties->UseAddLnk   = LibBoolToBool(GEEntityProperties->UseAddLnk);
}

//-------------------------------------------------------------------------------------------------------------
void TTransformEntitiesGE::ClearEntities()
{
  ClearGEEntities();
}

//-------------------------------------------------------------------------------------------------------------
int TTransformEntitiesGE::GetCountEntites()
{
  return GetCountGEEntites();
}

//-------------------------------------------------------------------------------------------------------------
void TTransformEntitiesGE::AddPointToEntity(const int EntIndex, 
                                            const LPCTSTR lpPntName, 
                                            const double EorPhi, const double NorLam)
{
  AddPointToGEEntity(EntIndex, StrTCharToWChar(lpPntName), EorPhi, NorLam);
}

//-------------------------------------------------------------------------------------------------------------
void TTransformEntitiesGE::SetPointToEntity(const int EntIndex, const int PntIndex, 
                                            const LPCTSTR lpPntName, 
                                            const double EorPhi, const double NorLam)
{
  SetPointToGEEntity(EntIndex, PntIndex, StrTCharToWChar(lpPntName), EorPhi, NorLam);
}

//-------------------------------------------------------------------------------------------------------------
BOOL TTransformEntitiesGE::GetPointFromEntity(const int EntIndex, const int PntIndex, 
                                              LPTSTR *lpPntName, 
                                              double *EorPhi, double *NorLam)
{
  int nMaxPntNameCount;
  #ifdef UNICODE
    return LibBoolToBool(GetPointFromGEEntity(EntIndex, PntIndex, lpPntName, &nMaxPntNameCount, EorPhi, NorLam));
  #else
    BOOL rslt;
    LPWSTR PntName;
    rslt = LibBoolToBool(GetPointFromGEEntity(EntIndex, PntIndex, &PntName, &nMaxPntNameCount, EorPhi, NorLam));
    *lpPntName      = StrWtoMB(PntName, nMaxPntNameCount);
    return rslt;
  #endif
}

//-------------------------------------------------------------------------------------------------------------
BOOL TTransformEntitiesGE::GetPointFromEntityFormated(const int EntIndex, const int PntIndex, 
                                                      LPTSTR *lpPntName, 
                                                      LPTSTR *lpStrEorPhi, LPTSTR *lpStrNorLam, 
                                                      const BOOL CoordIsGeog)
{
  int nMaxPntNameCount, nMaxEorPhiCount, nMaxNorLamCount;
  #ifdef UNICODE
    return LibBoolToBool(GetPointFromGEEntityFormated(EntIndex, PntIndex, lpPntName, &nMaxPntNameCount, 
                         lpStrEorPhi, &nMaxEorPhiCount, lpStrNorLam, &nMaxNorLamCount, 
                         CoordIsGeog, &GetAngleAspect(), DecNoNEH));
  #else
    BOOL rslt;
    LPWSTR PntName,StrEorPhi,StrNorLam;
    rslt = LibBoolToBool(GetPointFromGEEntityFormated(EntIndex, PntIndex, &PntName, &nMaxPntNameCount, 
                         &StrEorPhi, &nMaxEorPhiCount, &StrNorLam, &nMaxNorLamCount, 
                         CoordIsGeog, &GetAngleAspect(), DecNoNEH));
    *lpPntName      = StrWtoMB(PntName, nMaxPntNameCount);
    *lpStrEorPhi    = StrWtoMB(StrEorPhi, nMaxEorPhiCount);
    *lpStrNorLam    = StrWtoMB(StrNorLam, nMaxNorLamCount);
    return rslt;
  #endif
}

//-------------------------------------------------------------------------------------------------------------
int TTransformEntitiesGE::GetCountPointsOfEntity(const int EntIndex)
{
  return GetCountPointsOfGEEntity(EntIndex);
}

//-------------------------------------------------------------------------------------------------------------
void TTransformEntitiesGE::DeleteAllPointsOfEntity(const int EntIndex)
{
  DeleteAllPointsOfGEEntity(EntIndex);
}

//-------------------------------------------------------------------------------------------------------------
void TTransformEntitiesGE::CalculateAreaAndLengthToEntity(const int EntIndex)
{
  CalculateAreaAndLengthToGEEntity(EntIndex, FAreaUnits, DecNoArea, FLengthUnits, DecNoLength);
}

//-------------------------------------------------------------------------------------------------------------
BOOL TTransformEntitiesGE::LoadEntitiesFromFile(const LPCTSTR lpFileName)
{   
  BOOL rslt;
  int ErrNo, nMaxCount;
  LPWSTR lpErrTxt;

  rslt = LibBoolToBool(LoadGEEntitiesFromFile(StrTCharToWChar(lpFileName), InvertAxes12, &GetAngleAspect(), ChCsv, 
                                                 &ErrNo, &lpErrTxt, &nMaxCount));

  if ((rslt == FALSE) && (ErrNo > 0))
    ShowMessageError(ErrNo, lpErrTxt, nMaxCount);
  
  return rslt;
}

//-------------------------------------------------------------------------------------------------------------
BOOL TTransformEntitiesGE::SaveEntitiesToFile(const LPCTSTR lpFileName, 
                                              const TEncodingType EncodingType)
{
  BOOL rslt;
  int ErrNo, nMaxCount;
  LPWSTR lpErrTxt;

  //Possible extension of file: csv, kml or kmz.
  rslt = LibBoolToBool(SaveGEEntitiesToFile(StrTCharToWChar(lpFileName), StrTCharToWChar(ProgName), 
           StrTCharToWChar(ProgVer), StrTCharToWChar(WebPage), StrTCharToWChar(FlpPlaceName),
           InvertAxes12, &GetAngleAspect(), ChCsv, &FGEDrawOptions, &GEKmlLangWords, EncodingType, 
           &ErrNo, &lpErrTxt, &nMaxCount));

  if (ErrNo > 0)
    ShowMessageError(ErrNo, lpErrTxt, nMaxCount);

  return rslt;
}

//-------------------------------------------------------------------------------------------------------------
BOOL TTransformEntitiesGE::DrawEntitiesToGoogleEarth(const LPCTSTR lpTempFileName)
{
  int ErrNo, nMaxCount;
  LPWSTR lpErrTxt;
  BOOL rslt;

  //Google Earth must be installed
  rslt = DrawGEEntitiesToGoogleEarth(StrTCharToWChar(ProgName), StrTCharToWChar(ProgVer), StrTCharToWChar(WebPage),
    StrTCharToWChar(FlpPlaceName), StrTCharToWChar(lpTempFileName), &FGEDrawOptions, &GEKmlLangWords,
    &ErrNo, &lpErrTxt, &nMaxCount);
  
  if (TempFilesIsUsed == FALSE)
    TempFilesIsUsed = rslt;

  if (ErrNo > 0)
    ShowMessageError(ErrNo, lpErrTxt, nMaxCount);

  return rslt;
}

//-------------------------------------------------------------------------------------------------------------
BOOL TTransformEntitiesGE::SaveZoomToFile(const LPCTSTR lpFileName, const LPCTSTR lpFolderName,
                                          const double PhiMin, const double LamMin,
                                          const double PhiMax, const double LamMax)
{
  BOOL rslt;

  //Only kml extension of file.
  rslt = LibBoolToBool(SaveGEZoomToFile(StrTCharToWChar(lpFileName), StrTCharToWChar(lpFolderName), PhiMin, LamMin,
    PhiMax, LamMax));
  return rslt;
}
//-------------------------------------------------------------------------------------------------------------
BOOL TTransformEntitiesGE::DrawZoomToGoogleEarth(const double PhiMin, const double LamMin,
                                                 const double PhiMax, const double LamMax,
                                                 const LPCTSTR lpFolderName,
                                                 const LPCTSTR lpTempFileName)
{
  int ErrNo, nMaxCount;
  LPWSTR lpErrTxt;
  BOOL rslt;

  //Google Earth must be installed
  rslt = DrawGEZoomToGoogleEarth(StrTCharToWChar(lpTempFileName), StrTCharToWChar(lpFolderName), PhiMin, LamMin, 
    PhiMax, LamMax, &ErrNo, &lpErrTxt, &nMaxCount);

  if (TempFilesIsUsed == FALSE)
    TempFilesIsUsed = rslt;

  if (ErrNo > 0)
    ShowMessageError(ErrNo, lpErrTxt, nMaxCount);

  return rslt;
}

//-------------------------------------------------------------------------------------------------------------
BOOL TTransformEntitiesGE::TransformPointsOfAllEntities(TProgressProc ProgressProc)
{
  BOOL rslt;
  int ErrNo, nMaxCount;
  LPWSTR lpErrTxt;

  //It is recommended as the points to be in projected coordinate system (N,E).
  rslt = LibBoolToBool(TransformPointsOfAllGEEntities(ProgressProc, strCooOpForErr, &ErrNo, &lpErrTxt, &nMaxCount));

  if ((rslt == FALSE) && (ErrNo > 0))
    ShowMessageError(ErrNo, lpErrTxt, nMaxCount);
  
  return rslt;
}

//-------------------------------------------------------------------------------------------------------------
void TTransformEntitiesGE::set_GEDrawOptions(TGEDrawOptions v)
{
  StrWCopy(FGEDrawOptions.PlgLabelsHtmlColor, v.PlgLabelsHtmlColor, MAX_LEN_HTML_COLOR);
  StrWCopy(FGEDrawOptions.PlgLinesHtmlColor, v.PlgLinesHtmlColor, MAX_LEN_HTML_COLOR);
  FGEDrawOptions.PlgDrawLabels = v.PlgDrawLabels;
  FGEDrawOptions.PlgAddAreaToName = v.PlgAddAreaToName;
  StrWCopy(FGEDrawOptions.PathLabelsHtmlColor, v.PathLabelsHtmlColor, MAX_LEN_HTML_COLOR);
  FGEDrawOptions.PathDrawLabels = v.PathDrawLabels;
  FGEDrawOptions.PathAddLengthToName = v.PathAddLengthToName;
  FGEDrawOptions.PathIdxSymbIcon = v.PathIdxSymbIcon;
  StrWCopy(FGEDrawOptions.PtsLabelsHtmlColor, v.PtsLabelsHtmlColor, MAX_LEN_HTML_COLOR);
  FGEDrawOptions.AddDescrToName = v.AddDescrToName;
  FGEDrawOptions.LabelsDistToViewKm = v.LabelsDistToViewKm;  
  StrWCopy(FGEDrawOptions.FoldPlg, v.FoldPlg, MAX_LEN_FOLDER_NAME);
  StrWCopy(FGEDrawOptions.FoldPath, v.FoldPath, MAX_LEN_FOLDER_NAME);
  StrWCopy(FGEDrawOptions.FoldGrpPts, v.FoldGrpPts, MAX_LEN_FOLDER_NAME);
  FGEDrawOptions.CorPhi = v.CorPhi;
  FGEDrawOptions.CorLam = v.CorLam;
}

//-------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------

#endif

